searchNodes=[{"doc":"Image is based upon the fabulous vix library that provides a libvips wrapper for Elixir. Image is intended to provide well-documented common image processing functions in an idiomatic Elixir functional style as a layer above the very comprehensive set of functions in Vix and libvips . In a very simple image resizing benchmark , Image is approximately 2 to 3 times faster than Mogrify and uses about 5 times less memory.","ref":"Image.html","title":"Image","type":"module"},{"doc":"Returns the band number of the alpha channel of an image, or nil if it doesn't have one. The determination is a heuristic so certainty cannot be guaranteed. Arguments image is any Vix.Vips.Image.t/0 . Returns An integer in the range 1..4 depending on the image interpretation. Returns nil if there is no alpha band.","ref":"Image.html#alpha_band/1","title":"Image.alpha_band/1","type":"function"},{"doc":"Rotate an image based upon the orientation information in an image's EXIF data. Returns a potentially rotated image or raises and exception. Arguments image is any Vix.Vips.Image.t/0 . Returns auto_rotated_image or raises an exception.","ref":"Image.html#autorotate!/1","title":"Image.autorotate!/1","type":"function"},{"doc":"Rotate an image based upon the orientation information in an image's EXIF data. Arguments image is any Vix.Vips.Image.t/0 . Returns {:ok, {auto_rotated_image, flags}} or {:error, reason} Flags Two flags are returned indicating what action was taken: :flip which is a boolean indicating if the image was flipped or not and :angle through which the image was rotated. This value will be one of 0 , 90 , 180 or 270 representing the degrees of rotation.","ref":"Image.html#autorotate/1","title":"Image.autorotate/1","type":"function"},{"doc":"Make a circular image intended to be used as an avatar image returning an image or raising an exception. The image is resized, a circular mask is applied and all metadata is removed from the image. Arguments image is any Vix.Vips.Image.t/0 . size is the diameter of the resulting image after resizing. The default value is 180 . options is a keyword list of options. See Image.resize/3 for the valid options. Returns avatar_image or raises an exception.","ref":"Image.html#avatar!/3","title":"Image.avatar!/3","type":"function"},{"doc":"Make a circular image intended to be used as an avatar image. The image is resized, a circular mask is applied and all metadata is removed from the image. Arguments image is any Vix.Vips.Image.t/0 . size is the diameter of the resulting image after resizing. The default value is 180 . options is a keyword list of options. See Image.resize/3 for the valid options. Returns {:ok, avatar_image} or {:error, reason}","ref":"Image.html#avatar/3","title":"Image.avatar/3","type":"function"},{"doc":"Return the number of bands in an image. A band is sometimes referred to as a channel. Note than bands are 0-indexed. That is, the first band is band 0, the second band is band 1 and so on. Arguments image is any Vix.Vips.Image.t/0 . Returns An integer number of bands in the image.","ref":"Image.html#bands/1","title":"Image.bands/1","type":"function"},{"doc":"Apply a circular mask to an image returning an image or raising an exception. The returned image has an alpha band masking the circular image. As a result, it is best saved to a format, like .png that supports alpha transparency. Note that .jpg files do not support alpha transparency. Arguments image is any Vix.Vips.Image.t/0 . Returns circular_image or raises an exception.","ref":"Image.html#circle!/2","title":"Image.circle!/2","type":"function"},{"doc":"Apply a circular mask to an image. The returned image has an alpha band masking the circular image. As a result, it is best saved to a format, like .png that supports alpha transparency. Note that .jpg files do not support alpha transparency. Arguments image is any Vix.Vips.Image.t/0 . Returns {:ok, circular_image} or {:error, reason}","ref":"Image.html#circle/2","title":"Image.circle/2","type":"function"},{"doc":"Compose two images together to form a new image or raise an exception. Arguments base_image is any Vix.Vips.Image.t/0 . overlay_image is any Vix.Vips.Image.t/0 that will be composed over the top of base_image . options is a keyword list of options. Options :blend_mode is the manner in which the two images are composited. See Image.BlendMode.t/0 . The default is :over which is the most common blend mode. :x is the offset (0-based) from the left of the base_image where the overlay_image will be placed. It may also be one of the keywords :left , :right or :center . The default is :center . :y is the offset (0-based) from the top of the base_image where the overlay_image will be placed. It may also be one of the keywords :top , :bottom or :middle . The default is :middle . Composition list options When overlay_image is an image_list , each entry in the list is either a Vix.Vips.Image.t/0 or a composition/0 . A composition supports the specification of how a particular image is composed onto the base image. :x describes the absolute x offset on the base image where this image will be placed. If this option is set to :left , :center or :right then the x position will be calculated relative to the base image. If :x is nil (the default) then the image will be placed according to the relative offset of the previously composed image using :dx . :y describes the absolute y offset on the base image where this image will be placed. If this option is set to :top , :middle or :bottom then the y position will be calculated relative to the base image. If :y is nil (the default) then the image will be placed according to the relative offset of the previously composed image using :dy . :dx describes the relative offset used to calculate the x value. :dx is an integer offset from the edge of the previously composed image. Which edge is determined by the :x_baseline option. If :x is also specified then :x is first calculated, then :dx is added to it. In this case, :x_baseline is ignored. :dy describes the relative offset used to calculate the y value. :dy is an integer offset from the edge of the previously composed image. Which edge is determined by the :y_baseline option. If :y is also specified then :y is first calculated, then :dy is added to it. In this case, :x_baseline is ignored. :blend_mode is the Image.BlendMode.t/0 used when composing this image over its base image. The default is :over which is appropriate for most use cases. :x_baseline establishes the baseline on the previously composed image from which :dx is calculated. The default is :right . :y_baseline establishes the baseline on the previously composed image from which :dy is calculated. The default is :bottom . Returns composed_image or raises an exception Examples # Compose images over a base image using # absolute coordinates from the base image # to place each overlay image #==&gt; base_image ...&gt; |&gt; Image . compose! ( polygon , x : :middle , y : :top ) ...&gt; |&gt; Image . compose! ( explore_new , x : 260 , y : 200 ) ...&gt; |&gt; Image . compose! ( places , x : 260 , y : 260 ) ...&gt; |&gt; Image . compose! ( blowout , x : 260 , y : 340 ) ...&gt; |&gt; Image . compose! ( start_saving , x : 260 , y : 400 ) # Compose images over a base image # using a composition list and coordinates # that are either absolute with respect to the # base image or relative to the previously # composed image #==&gt; base_image ...&gt; |&gt; Image . compose! ( [ ...&gt; { polygon , x : :center , y : :top } , ...&gt; { explore_new , y_baseline : :top , x_baseline : :left , dx : 20 , dy : 200 } , ...&gt; { places , dy : 10 } , ...&gt; { blowout , dy : 20 } , ...&gt; { start_saving , dy : 50 } ...&gt; ] )","ref":"Image.html#compose!/3","title":"Image.compose!/3","type":"function"},{"doc":"Compose two images together to form a new image. Arguments base_image is any Vix.Vips.Image.t/0 . overlay_image is any Vix.Vips.Image.t/0 that will be composed over the top of base_image . It can also be a list of composition/0 s that allow for multiple images to be composed in a single call. options is a keyword list of options. Options for a single overlay image :blend_mode is the manner in which the two images are composited. See t:Image.BkendMode.t/0 . The default is :over which is the most common blend mode. :x is the offset (0-based) from the left of the base_image where the overlay_image will be placed. It may also be one of the keywords :left , :right or :center . The default is :center . :y is the offset (0-based) from the top of the base_image where the overlay_image will be placed. It may also be one of the keywords :top , :bottom or :middle . The default is :middle . Composition list options When overlay_image is an image_list , each entry in the list is either a Vix.Vips.Image.t/0 or a composition/0 . A composition supports the specification of how a particular image is composed onto the base image. :x describes the absolute x offset on the base image where this image will be placed. If this option is set to :left , :center or :right then the x position will be calculated relative to the base image. If :x is nil (the default) then the image will be placed according to the relative offset of the previously composed image using :dx . :y describes the absolute y offset on the base image where this image will be placed. If this option is set to :top , :middle or :bottom then the y position will be calculated relative to the base image. If :y is nil (the default) then the image will be placed according to the relative offset of the previously composed image using :dy . :dx describes the relative offset used to calculate the x value. :dx is an integer offset from the edge of the previously composed image. Which edge is determined by the :x_baseline option. If :x is also specified then :x is first calculated, then :dx is added to it. In this case, :x_baseline is ignored. :dy describes the relative offset used to calculate the y value. :dy is an integer offset from the edge of the previously composed image. Which edge is determined by the :y_baseline option. If :y is also specified then :y is first calculated, then :dy is added to it. In this case, :x_baseline is ignored. :blend_mode is the Image.BlendMode.t/0 used when composing this image over its base image. The default is :over which is appropriate for most use cases. :x_baseline establishes the baseline on the previously composed image from which :dx is calculated. The default is :right . :y_baseline establishes the baseline on the previously composed image from which :dy is calculated. The default is :bottom . Returns {:ok, composed_image} or {:error, reason} Examples # Compose images over a base image using # absolute coordinates from the base image # to place each overlay image #==&gt; {:ok, image} = Image.compose(base_image, polygon, x: :middle, y: :top) #==&gt; {:ok, image} = Image.compose(image, explore_new, x: 260, y: 200) #==&gt; {:ok, image} = Image.compose(image, places, x: 260, y: 260) #==&gt; {:ok, image} = Image.compose(image, blowout, x: 260, y: 340) #==&gt; {:ok, image} = Image.compose(image, start_saving, x: 260, y: 400) # Compose images over a base image # using a composition list and coordinates # that are either absolute with respect to the # base image or relative to the previously # composed image #==&gt; Image.compose(base_image, [ ...&gt; { polygon , x : :center , y : :top } , ...&gt; { explore_new , y_baseline : :top , x_baseline : :left , dx : 20 , dy : 200 } , ...&gt; { places , dy : 10 } , ...&gt; { blowout , dy : 20 } , ...&gt; { start_saving , dy : 50 } ...&gt; ] )","ref":"Image.html#compose/3","title":"Image.compose/3","type":"function"},{"doc":"Convert an image into a mask returning an image or raising an exception. Takes an image, extracts its alpha channel which holds the opacity information and inverts the content. Arguments image is any Vix.Vips.Image.t/0 Returns mask image or raises an exception","ref":"Image.html#convert_to_mask!/1","title":"Image.convert_to_mask!/1","type":"function"},{"doc":"Convert an image into a mask. Takes an image, extracts its alpha channel which holds the opacity information and inverts the content. Arguments image is any Vix.Vips.Image.t/0 Returns {:ok, mask} or {:error, reason}","ref":"Image.html#convert_to_mask/1","title":"Image.convert_to_mask/1","type":"function"},{"doc":"Crop an image returning a cropped image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 . left is the left edge of extract area as a positive integer. top is the top edge of extract area as an integer. If top is positive it is relative to the top of the image. If it is negative it is relative to the bottom of the image. width is the width of extract area as a positive integer. height is the height of extract area as a positive integer. Returns cropped_image or raises an exception.","ref":"Image.html#crop!/5","title":"Image.crop!/5","type":"function"},{"doc":"Crop an image. Arguments image is any Vix.Vips.Image.t/0 . left is the top edge of crop area as an integer. If left is positive it is relative to the left edge of the image. If it is negative it is relative to the right edge of the image. top is the top edge of crop area as an integer. If top is positive it is relative to the top edge of the image. If it is negative it is relative to the bottom edge of the image. width is the width of area remaining as a positive integer. height is the height of the area remaining as a positive integer. Notes left is 0-indexed. That is, the leftmost edge of the image starts at 0 . top is 0-indexed. That is, the toptmost edge of the image starts at 0 . Returns {:ok, cropped_image} or {:error, reason}","ref":"Image.html#crop/5","title":"Image.crop/5","type":"function"},{"doc":"Returns a 512-bit difference hash as a binary. Image hashes can be used to compare the similarity of images. See Image.hamming_distance/2 . dhash is generates a &quot;difference hash&quot; for a given image -- a perceptual hash based on Neal Krawetz's dHash algorithm in a Hacker Factor blog entry. The code is adapted from the Ruby implementation in dhash-vips . Arguments image is any Vix.Vips.Image.t/0 . Returns {:ok, 512-bit binary} or {:error, reason}","ref":"Image.html#dhash/2","title":"Image.dhash/2","type":"function"},{"doc":"Returns the dominant color of an image as an RBG triplet value in an integer list. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. The default is [] . Options :bins is an integer number of color frequency bins the image is divided into. The default is 10 . Returns [r, g, b]","ref":"Image.html#dominant_color/2","title":"Image.dominant_color/2","type":"function"},{"doc":"Returns the EXIF data for an image as a map. Only a subset of EXIF data is returned but its a substantial subset. Arguments image is any Vix.Vips.Image.t/0 Returns {:ok, exif_map} where exif_map is a map of selected EXIF data.","ref":"Image.html#exif/1","title":"Image.exif/1","type":"function"},{"doc":"Returns the fast fourier transform (fft) of the given image returning an image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 Returns fft_image or raises an exception Example Image . fft! ( image )","ref":"Image.html#fft!/1","title":"Image.fft!/1","type":"function"},{"doc":"Returns the fast fourier transform (fft) of the given image. Arguments image is any Vix.Vips.Image.t/0 Returns {:ok, fft_image} or {:error, reason} Example Image . fft ( image )","ref":"Image.html#fft/1","title":"Image.fft/1","type":"function"},{"doc":"Returns the filename for an image. Arguments image is any Vix.Vips.Image.t/0 . Returns The pathname from which the image was opened or nil if there is no associated path. This can happen in the case of a streamed image or an image created from a memory buffer.","ref":"Image.html#filename/1","title":"Image.filename/1","type":"function"},{"doc":"Flip an image horizontally or vertically returning a flipped image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 . direction is either :horizontal or :vertical . Returns flipped_image or raises an exception.","ref":"Image.html#flip!/2","title":"Image.flip!/2","type":"function"},{"doc":"Flip an image horizontally or vertically. Arguments image is any Vix.Vips.Image.t/0 . direction is either :horizontal or :vertical . Returns {:ok, flipped_image} or {:error, reason}","ref":"Image.html#flip/2","title":"Image.flip/2","type":"function"},{"doc":"Returns a image created from an in-memory binary representation of an image. The binary must be a complete formatted image such as that returned from File.read!/1 . Arguments binary is a binary representation of a formatted image options is a keyword list of options. See Image.open/2 for the list of applicable options. Returns {:ok, image} or {:error, reason}","ref":"Image.html#from_binary/2","title":"Image.from_binary/2","type":"function"},{"doc":"Converts to an Image image from an Evision image. Arguments evision_image is any Evision image. Returns {:ok, image} Notes Image images have the shape {width, height, bands} whereas Evision images have the shape {height, width, bands} so this function transposes the dimensions to match. Image data is arranged as rgb data elements whereas Evision requires the data to be in bgr order. This function also reorders the data appropriately.","ref":"Image.html#from_evision/1","title":"Image.from_evision/1","type":"function"},{"doc":"Converts an Nx tensor into an image. Arguments tensor is any three dimensional Nx.Tensor.t/0 . options is a keyword list of options. For valid options see Nx.from_binary/2 . Returns {:ok, image} or {:error, reason} Notes In order to convert a tensor into an image it must satisfy these constraints: It must have three dimensions. It must have a tensor type that is compatible with libvips (most tensors will satisfy this requirement other than tensors whose type is complex). The names of the axes must be [:width, :height, any_other] or [:height, :width, any_other] . Example iex&gt; { :ok , image } = Vix.Vips.Operation . black ( 3 , 3 ) iex&gt; { :ok , tensor } = Image . to_nx ( image ) iex&gt; { :ok , _image_2 } = Image . from_nx ( tensor )","ref":"Image.html#from_nx/1","title":"Image.from_nx/1","type":"function"},{"doc":"Returns the number of operating system threads available for use by libvips . By default the number of threads will be the number of cores in the system. Since image processing is CPU intensive it may be appropriate to reduce the number of threads to be available to reduce the risk of CPU starvation for other workloads. See Image.put_concurrency/1 .","ref":"Image.html#get_concurrency/0","title":"Image.get_concurrency/0","type":"function"},{"doc":"Returns the pixel value at the given image location. The returned pixel is a list of numbers where the length of the list is equal to the number of bands in the image. Arguments image is any Vix.Vips.Image.t/0 . x is an integer offset from the top left of the image along the x (width) axis. The number must be in the range 0..width - 1 . y is an integer offset from the top left of the image along the y (height) axis. The number must be in the range 0..height - 1 . Returns {:ok, pixel_value} or {:error, reason}","ref":"Image.html#get_pixel/3","title":"Image.get_pixel/3","type":"function"},{"doc":"Returns the hamming distance of two images or two image hashes. A hamming distance gives an indication of the similarity of two images. In general, a hamming distance of less than 10 indicates that the images are very similar. A distance of less than 20 suggests the images are quite similar. Any other distance suggests the images have little in common. Arguments image_1 is any Vix.Vips.Image.t/0 image_2 is any Vix.Vips.Image.t/0 Alternatively, both arguments may be image hashes returned by Image.dhash/1 . Both arguments must be of the same type. Returns {:ok, hamming_distance} where hamming distance is a positive integer or {:error, reason} .","ref":"Image.html#hamming_distance/2","title":"Image.hamming_distance/2","type":"function"},{"doc":"Returns a boolean based upon whether a given image has an alpha band. The determination is a heuristic so certainty cannot be guaranteed. Arguments image is any Vix.Vips.Image.t/0 . Returns true or false","ref":"Image.html#has_alpha?/1","title":"Image.has_alpha?/1","type":"function"},{"doc":"Returns the height of an image. Arguments image is any Vix.Vips.Image.t/0 Returns The image height as an integer.","ref":"Image.html#height/1","title":"Image.height/1","type":"function"},{"doc":"Returns the histogram for an image. The histogram is returned as a t:Vimage.t/0 that is a 255 by 255 image with three bands. Argument image is any Vix.Vips.Image.t/0 . Returns {:ok, histogram_image} or {:error, reason} Notes The returned image is is organized as a 256x256 pixel image with the same number of bands as the original image. Each pixel on the image returns the count of pixels in the original image that are in that 1/256th part of the image.","ref":"Image.html#histogram/1","title":"Image.histogram/1","type":"function"},{"doc":"Returns the image interpretation. The interpretation is how Image understands the image date. For example, :srgb or :cmyk or :bw . For most common web applications, the interpretation will be :srgb . Arguments image is any Vix.Vips.Image.t/0 Returns The image interpretation as an atom. Notes See also Image.Interpretation.known_interpretations/0","ref":"Image.html#interpretation/1","title":"Image.interpretation/1","type":"function"},{"doc":"Guards whether the coordinates can be reasonably interpreted as a bounding box. left and top when positive are relative to the left and top of the image respectively. When negative they are relative to the right and bottom of the image.","ref":"Image.html#is_box/4","title":"Image.is_box/4","type":"macro"},{"doc":"Guards whether a term might be reasonably interpreted as an image pixel.","ref":"Image.html#is_pixel/1","title":"Image.is_pixel/1","type":"macro"},{"doc":"Guards whether a number can be reasonably interpreted as a size (as in size of a crop or mask)","ref":"Image.html#is_size/1","title":"Image.is_size/1","type":"macro"},{"doc":"Create an image gradient of the same size as the given image. Returns the gradient image or raises and exception. The gradient will interpolate from the start value to the finish value. The default start value is black with 100% transparency. The default finish value is black with 100% opacity. start and finish are given as an rgb triplet or quadruplet list of integers between 0 and 255 . Arguments image is any Vix.Vips.Image.t/0 :start is an rgb triplet or quadruplet list of numbers between 0 and 255 . * :finish is an rgb triplet or quadruplet list of numbers between 0 and 255 . Returns gradient_image or raises an exception. Example # transparent_black and opaque_black are the default # start and finish values transparent_black = [ 0 , 0 , 0 , 0 ] opaque_black = [ 0 , 0 , 0 , 255 ] gradient = Image . linear_gradient! ( image , transparent_black , opaque_black )","ref":"Image.html#linear_gradient!/3","title":"Image.linear_gradient!/3","type":"function"},{"doc":"Create an image gradient of the same size as the given image. The gradient will interpolate from the start value to the finish value. The default start value is black with 100% transparency. The default finish value is black with 100% opacity. start and finish are given as an rgb triplet or quadruplet list of integers between 0 and 255 . Arguments image is any Vix.Vips.Image.t/0 :start is an rgb triplet or quadruplet list of numbers between 0 and 255 . * :finish is an rgb triplet or quadruplet list of numbers between 0 and 255 . Returns {:ok, gradient_image} or {:error, reason} Example # transparent_black and opaque_black are the default # start and finish values transparent_black = [ 0 , 0 , 0 , 0 ] opaque_black = [ 0 , 0 , 0 , 255 ] { :ok , gradient } = Image . linear_gradient ( image , transparent_black , opaque_black )","ref":"Image.html#linear_gradient/3","title":"Image.linear_gradient/3","type":"function"},{"doc":"Minimize metadata by keeping only the artist and copyright (if available). See also Image.minimize_metadata/1 . Arguments image is any Vix.Vips.Image.t/0 Returns image_with_minimal_metadata or raises an exception.","ref":"Image.html#minimize_metadata!/1","title":"Image.minimize_metadata!/1","type":"function"},{"doc":"Minimize metadata by keeping only the artist and copyright (if available). Removing metadata from an image can greatly reduce the overall size of an image. The proprtional reduction is most noticeable with smaller images which are very common in web applications. Removing all metadata is a common option however with intellectual property concerns in mind this function will keep the artist and copyright fields if they exist in the original image. On a 1000x500px image exported from Adobe Lightroom with metadata intact, removing the metadata results in am approximately 50% saving in file size due to the removal of most EXIF and all IPTC and XMP metadata. Arguments image is any Vix.Vips.Image.t/0 Returns {:ok, image_with_minimal_metadata} or {:error, reason}","ref":"Image.html#minimize_metadata/1","title":"Image.minimize_metadata/1","type":"function"},{"doc":"Mutate an image with through the given function. This funcation is a convenience wrapper around Vix.Vips.Image.mutate/2 .","ref":"Image.html#mutate/2","title":"Image.mutate/2","type":"function"},{"doc":"Create a new image of the given dimensions and background color. Arguments width is the image width as an integer. height is the image height as an integer. options is a keyword list of options. Options :bands defines the number of bands (channels) to be created. The default is 3 . :color defines the color of the image. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The default is 0 , meaning black. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . :format defines the format of the image. The default is {:u, 8} . :interpretation defines the interpretation of the image. The default is :srgb . Returns {:ok, image} or {:error, reason} Examples # 100x100 pixel image of dark blue slate color iex&gt; { :ok , _image } = Image . new ( 100 , 100 , color : :dark_slate_blue ) # 100x100 pixel green image, fully transparent iex&gt; { :ok , _image } = Image . new ( 100 , 100 , color : [ 0 , 255 , 0 , 1 ] , bands : 4 )","ref":"Image.html#new/3","title":"Image.new/3","type":"function"},{"doc":"Opens an image file for image processing returning an image or raising an exception. Arguments image_path is the file system path to an image file. options is a keyword list of options. See Image.open/2 . Returns image or raises an exception.","ref":"Image.html#open!/2","title":"Image.open!/2","type":"function"},{"doc":"Opens an image file or stream for image processing. Arguments image_path_or_stream_or_binary is the file system path to an image file or a File.Stream.t/0 or any Enumerable.t/0 . It can also be any binary .jpg , .png or .webp image. options is a keyword list of options. The default is [access: :sequential] for all images except images derived from binary image data. Options The available options depend upon the image type. All image types :access is the file access mode, either :random or :sequential . The default is :sequentual . When :sequential , Image (via Vix ) is able to support streaming transformations and optimise memory usage more effectively. Howwevef :sequenial also means that some operationas cannot be completed because they would require non-sequential access to the image. In these cases, :random access is required. :fail_on sets the error level at which image loading and decoding will stop. The default is :none . Each error state implies all the states before it such that :error implies also :truncated . JPEG image options :shrink is an integer factor in the range 1..16 by which the image is reduced upon loading. This is an optimization that can result in improved performance and reduced memory usage if the image is being loaded with the intent to resize it to smaller dimensions. The default value is 1 meaning no shrnk-on-load. :autorotate is a boolean value indicating if the image should be rotated according to the orientation data stored in the image metadata. The default is false . Webp options :scale will scale the image on load. The value is 1..1024 with a default of 1 . :page indicates the image page to be loaded. The value is in the range 0..100_000 with a default value of 0 . :pages indicates how many pages to load. The value is in the range 1..100_000 with a default value of 1 . TIFF options :autorotate is a boolean value indicating if the image should be rotated according to the orientation data stored in the image metadata. The default is false . :page indicates the image page to be loaded. The value is in the range 0..100_000 with a default value of 0 . :pages indicates how many pages to load. The value is in the range 1..100_000 with a default value of 1 . PNG options There are no PNG-specific image loading options. Returns {:ok, image} or {:error, message}","ref":"Image.html#open/2","title":"Image.open/2","type":"function"},{"doc":"Returns the orientation of an image. Arguments image is any Vix.Vips.Image.t/0 options is a keyword list of options Options :square_ratio indicates when an image is to be considered square. It is a floating point indicator of the ratio between the width and height below which the image is considered square. The default is 0.0 meaning that the dimensions must be exactly equal in order for the image to be considered square. Returns Either :landscape , :portrait or :square . Example iex&gt; puppy = Image . open! ( Path . expand ( &quot;images/puppy.webp&quot; ) ) iex&gt; Image . orientation ( puppy , square_ratio : 0.05 ) :landscape","ref":"Image.html#orientation/2","title":"Image.orientation/2","type":"function"},{"doc":"Sets the number of available threads for use by libvips . By default this is the same as the number of cores in the system. Reducing this number may prevent CPU starvation for other workloads. Arguments concurrency is a positive integer denoting the maximum number of threads that libvips will use for concurrency. Returns {:ok, updated_concurrency}","ref":"Image.html#put_concurrency/1","title":"Image.put_concurrency/1","type":"function"},{"doc":"Returns a radial gradient as an image. This image might then be composited over another image. Arguments width is the width of the gradient in pixels. height is the height of the gradient in pixels. options is a keyword list of options. The default is [] . Options :start is the color from which the gradient starts in the center of the image. :finish is the color at which the gradient finishes at the end of the gradient. :feather is the slope of the gradient. That it, how quickly the gradient moves from the :start color to the :finish color. The valid range is 1..10 representing the smallest amount of feather (harshest transition) to the largest amount of feather (smoothest transition). Returns {:ok, gradient_image} or {:error, reason}","ref":"Image.html#radial_gradient/3","title":"Image.radial_gradient/3","type":"function"},{"doc":"Remove metadata from an image returning an image or raising an exception. This can significant;y reduce the size of an image file. Arguments image is any Vix.Vips.Image.t/0 fields is a list of metadata field names as strings. The default is all known field names. There are some special field names interpreted by Image to simplify metadata removal these are: :exif which means remove all EXIF metadata :iptc which means remove all IPTC metadata :xmp which means remove all xmp data Notes The available field names (ie. metadata fields) in an image can be returned with a call to Vix.Vips.Image.header_field_names/1 . Errors removing metadata fields is not propagated into the return for this function. Errors might occur when attempting to remove metadata fields that do not exist in the image. Returns image_without_metadata_fields or raises an exception.","ref":"Image.html#remove_metadata!/2","title":"Image.remove_metadata!/2","type":"function"},{"doc":"Remove metadata from an image returning an updated image or raising an exception. This can significantly reduce the size of an image file. Arguments image is any Vix.Vips.Image.t/0 fields is a list of metadata field names as strings. The default is all known field names. There are some special field names interpreted by Image to simplify metadata removal these are: :exif which means remove all EXIF metadata :iptc which means remove all IPTC metadata :xmp which means remove all xmp data Notes The available field names (ie. metadata fields) in an image can be returned with a call to Vix.Vips.Image.header_field_names/1 . Errors removing metadata fields is not propagated into the return for this function. Errors might occur when attempting to remove metadata fields that do not exist in the image. Returns {:ok, image_without_metadata_fields} or {:error, reason}","ref":"Image.html#remove_metadata/2","title":"Image.remove_metadata/2","type":"function"},{"doc":"Resize an image to fit or fill a bounding box returning an image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 or a pathname to an image file. width is the integer width of the resulting image after resizing. It can also be of the form &quot;&lt;width&gt;x&lt;height&gt;&quot;. That is, a string with the width and height separated by an x . The &lt;height&gt; may be omitted in which case it is the same as providing an integer width. options is a keyword list of options. See Image.resize/3 . Returns image or raises an exception.","ref":"Image.html#resize!/3","title":"Image.resize!/3","type":"function"},{"doc":"Resize an image to fit or fill a bounding box. Arguments image is any Vix.Vips.Image.t/0 or a pathname to an image file. width is the integer width of the resulting image after resizing. It can also be of the form &quot;&lt;width&gt;x&lt;height&gt;&quot;. That is, a string with the width and height separated by an x . The &lt;height&gt; may be omitted in which case it is the same as providing an integer width. options is a keyword list of options. Options :crop determines if the strategy is &quot;resize to fit&quot; (crop is :none ) or &quot;resize to fill&quot; (when the crop option is not :none . The value may be one of :none , :center , :entropy , :attention , :low or :high . The default is :none . See also Image.Options.Crop.crop_focus/0 . :autorotate is a boolean indicating if the image should be autorated based upon the image metadata. The default is true . :intent indicates the rendering intent. The default is :relative . See also Image.render_intent/0 . :export_icc_profile -Indicates the icc profile to be attached to the resized image. The value may be an inbuilt profile ( :srgb , :p3 or :cmyk ), the name of an icc profile in the systems profile directory or a full path to an icc profile file. The default is to export the icc profile of the resized image if there is one. :import_icc_profile -Indicates the icc profile to be attached to the input image. The value may be an inbuilt profile ( :srgb , :p3 or :cmyk ), the name of an icc profile in the systems profile directory or a full path to an icc profile file. The default is to use the icc profile of the input image if there is one. :linear is a boolean indicating of the image should be resized in linear space. The default false . Shrinking is normally done in sRGB colourspace. Set linear to shrink in linear light colourspace instead. This can give better results, but can also be far slower, since tricks like JPEG shrink-on-load cannot be used in linear space. :resize determines if an image may be only upsized, only downsized, or both. The value may be one of :up , :down , :both or :force . The default is :both . :height - Size to this height. Default is to maintain the image aspect ratio unless resize: :force is set. Returns {:ok, resized_image} or {:error, reason}","ref":"Image.html#resize/3","title":"Image.resize/3","type":"function"},{"doc":"Adds a concentric ripple effect to an image returning an image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 . Returns image_with_ripple or raises an exception.","ref":"Image.html#ripple!/1","title":"Image.ripple!/1","type":"function"},{"doc":"Adds a concentric ripple effect to an image. Arguments image is any Vix.Vips.Image.t/0 . Returns {:ok, image_with_ripple} or {:error, reason}","ref":"Image.html#ripple/1","title":"Image.ripple/1","type":"function"},{"doc":"Rotate an image clockwise (to the right) by a number of degrees. Arguments image is any Vix.Vips.Image.t/0 . angle is a float number of degrees to rotate in a clockwise direction. options is a keyword list of options. See Image.rotate/3 . Notes The displacement parameters cause the image canvas to be expanded and the image displaced, relative to the top left corner of the image, by the amount specified. The rules defining how the image canvas is expanded is not known to the author of Image . Experimentation will be required if you explore these options. Returns rotated_image or raises an exception.","ref":"Image.html#rotate!/3","title":"Image.rotate!/3","type":"function"},{"doc":"Rotate an image clockwise (to the right) by a number of degrees. Arguments image is any Vix.Vips.Image.t/0 . angle is a float number of degrees to rotate in a clockwise direction. options is a keyword list of options. Options :idy is the vertical input displacement which defaults to 0.0 :idx is the horizontal input displacement which defaults to 0.0 :ody is the vertical output displacement which defaults to 0.0 :odx is the horizontal output displacement which defaults to 0.0 :background is the background color to be used for filling the blank areas of the image. The background is specified as a list of 3 or 4 float values depending on the image color space. Notes The displacement parameters cause the image canvas to be expanded and the image displaced, relative to the top left corner of the image, by the amount specified. The rules defining how the image canvas is expanded is not known to the author of Image . Experimentation will be required if you explore these options. Returns {:ok, rotated_image} or {:error, reason}","ref":"Image.html#rotate/3","title":"Image.rotate/3","type":"function"},{"doc":"Apply rounded corners to an image. Returns an image or raises an exception. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :radius is the desired corner radius. The default is 50. Returns rounded_corner_image or raises an exception.","ref":"Image.html#rounded!/2","title":"Image.rounded!/2","type":"function"},{"doc":"Apply rounded corners to an image. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :radius is the desired corner radius. The default is 50. Returns {:ok, rounded_corner_image} or {:error, reason}","ref":"Image.html#rounded/2","title":"Image.rounded/2","type":"function"},{"doc":"Returns the shape of an image. Arguments image is any Vix.Vips.Image.t/0 Returns The image shape as a tuple of {width, height, bands}","ref":"Image.html#shape/1","title":"Image.shape/1","type":"function"},{"doc":"Attempts top determine the distance from the perpendicular for a given image. The principle is that rotating the image by the skew angle should return an image in the upright position. The results are very image sensitive and perfect results are not guaranteed. The algorithm is an implementation of this stackoverflow post . Arguments image is any Vix.Vips.Image.t/0 Returns skew_angle which is a float number of degrees the image is tilted from the upright. Example skew_angle = skew_angle ( image ) Image . rotate ( image , skew_angle )","ref":"Image.html#skew_angle/1","title":"Image.skew_angle/1","type":"function"},{"doc":"Convert an image into an enumerable stream. Arguments image is any Vix.Vips.Image.t/0 . options is a keyword list of options. Options :buffer_size is the size in bytes for each chunk in the stream being written. Some services, like AWS S3, require a minumum 5 MiB per chunk to be delivered and this option can be used to satisfy that requirement. For additional options see Image.write/3 . Returns An Enumerable.t/0 suitable for streaming to an external service such as S3, Minio or any other enumerable consumer. Example In this example an image is opened, resized and then streamed into AWS S3: &quot;some/image.jpg&quot; |&gt; Image . open! ( ) |&gt; Image . resize! ( 200 ) |&gt; Image . stream! ( suffix : &quot;.jpg&quot; , buffer_size : 5_242_880 ) |&gt; ExAws.S3 . upload ( &quot;images&quot; , &quot;some_object_name.jpg&quot; ) |&gt; ExAws . request ( ) Since AWS S3 requires multipart uploads to be 5MiB per chunk, we specify the :buffer_size option to Image.stream!/2 .","ref":"Image.html#stream!/2","title":"Image.stream!/2","type":"function"},{"doc":"Converts an impage to the given colorspace returning an image or raising an exception. Available colorspaces are returned from Image.Interpretation.known_interpretations/0 . Arguments image is any Vix.Vips.Image.t/0 colorspace is any known colorspace. See Image.Interpretation.known_interpretations/0 for a list of the known colorspaces. Returns image_in_new_colorspace or raises an exception Example Image . to_colorspace! ( image , :bw )","ref":"Image.html#to_colorspace!/2","title":"Image.to_colorspace!/2","type":"function"},{"doc":"Converts an image to the given colorspace. Available colorspaces are returned from Image.Interpretation.known_interpretations/0 . Arguments image is any Vix.Vips.Image.t/0 colorspace is any known colorspace. See Image.Interpretation.known_interpretations/0 for a list of the known colorspaces. Returns {;ok, image_in_new_colorspace} or {:error, reason} Example Image . to_colorspace ( image , :bw )","ref":"Image.html#to_colorspace/2","title":"Image.to_colorspace/2","type":"function"},{"doc":"Converts an Image image to an Evision image. Note that only images with 3 bands can be transferred to eVision . Arguments image is any t:Vimage.t/0 Returns {:ok, evision_image} Notes Image images have the shape {width, height, bands} whereas Evision images have the shape {height, width, bands} so this function transposes the dimensions to match. Image data is arranged as rgb data elements whereas Evision requires the data to be in bgr order. This function also reorders the data appropriately.","ref":"Image.html#to_evision/1","title":"Image.to_evision/1","type":"function"},{"doc":"Converts an image into an Nx tensor. Arguments image is any t:Vimage.t/0 Returns An Nx.Tensor.t/0 tensor suitable for use in the Nx library. Example iex&gt; { :ok , image } = Vix.Vips.Operation . black ( 3 , 3 ) iex&gt; Image . to_nx ( image ) { :ok , Nx . tensor ( [ [ [ 0 ] , [ 0 ] , [ 0 ] ] , [ [ 0 ] , [ 0 ] , [ 0 ] ] , [ [ 0 ] , [ 0 ] , [ 0 ] ] ] , type : { :u , 8 } , names : [ :width , :height , :bands ] ) }","ref":"Image.html#to_nx/2","title":"Image.to_nx/2","type":"function"},{"doc":"Convert image to polar coordinates returning an image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 . Returns image_in_polar_coordinates or raises an exception.","ref":"Image.html#to_polar_coordinates!/1","title":"Image.to_polar_coordinates!/1","type":"function"},{"doc":"Convert image to polar coordinates. Arguments image is any Vix.Vips.Image.t/0 . Returns {:ok, image_in_polar_coordinates} or {:error, reason}","ref":"Image.html#to_polar_coordinates/1","title":"Image.to_polar_coordinates/1","type":"function"},{"doc":"Convert image to rectangular coordinates returning an image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 . Notes Roundtrip to polar and back to rectangular coordinates displays some image distortion, likely due to rounding errors in float arithmetic. Further study is required. Returns image_in_rectuangular_coordinates or raises an exception.","ref":"Image.html#to_rectangular_coordinates!/1","title":"Image.to_rectangular_coordinates!/1","type":"function"},{"doc":"Convert image to rectangular coordinates. Arguments image is any Vix.Vips.Image.t/0 . Notes Roundtrip to polar and back to rectangular coordinates displays some image distortion, likely due to rounding errors in float arithmetic. Further study is required. Returns {:ok, image_in_rectangular_coordinates} or {:error, reason}","ref":"Image.html#to_rectangular_coordinates/1","title":"Image.to_rectangular_coordinates/1","type":"function"},{"doc":"Returns the data type of the image pixels. Arguments image is any Vix.Vips.Image.t/0 Returns The image type as a tuple in the same format as Nx.Type.t/0 . For example {:u, 8} for a common :srgb image.","ref":"Image.html#type/1","title":"Image.type/1","type":"function"},{"doc":"Returns the version of libvips in operation.","ref":"Image.html#vips_version/0","title":"Image.vips_version/0","type":"function"},{"doc":"Returns the width of an image. Arguments image is any Vix.Vips.Image.t/0 Returns The image width as an integer.","ref":"Image.html#width/1","title":"Image.width/1","type":"function"},{"doc":"Write an image to a file, a stream or to memory returning the image or raising an exception. Arguments image is any Vix.Vips.Image.t/0 . image_path is the file system path to an image file. It may also be a stream created with File.stream!/3 or with Stream.resource/3 . Lastly, it can also be :memory in which case the image is written to a memory buffer. options is a keyword list of options. See Image.write/2 . Returns image or raises an exception.","ref":"Image.html#write!/3","title":"Image.write!/3","type":"function"},{"doc":"Write an image to a file, a stream, and enumerable or to memory. Arguments image is any Vix.Vips.Image.t/0 . image_path is the file system path to an image file. It may also be a stream created with File.stream!/3 or with Stream.resource/3 , a Plug.Conn.t/0 if Plug is configured or lastly, it can also be :memory in which case the image is written to a binary. options is a keyword list of options. The default is [] . Options The available options depends on the type of image file being opened. All image types :profile is the name of any ICC color profile . :strip is a boolean indicating if all metadata is to be stripped from the image. The default is false . :background is the background value to be used for any transparent areas of the image. Jpeg does not support alpha bands so a color value must be assigned. :quality which influences image compression and is a integer in the range 1..100 . The default for most image formats is 75 . For PNG files it is the quantization quality with a default of 100 . For HEIF files the default is 50 . Streaming images and :memory images :suffix must be specified so that the image is written in the correct format. For example: suffix: &quot;.jpg&quot; . JPEG images :progressive is a boolean indicating if the image should be interleaved rather than baseline. Progressive has the advantage of perceived time for the initial image load and the cost of multiple decoding passes on the client. For many applications :progressive is to be preferred but validation of this assumption for specific use cases is required. PNG images :color_depth is an integer describing the number of bits for each color. The value can be 1 , 2 , 4 , 8 or 16 . The default is to use the current color depth of the image. For web applications, 8 bits would be reasonable for photographic images with lower bit depths for monochromatic images or diagrams. :progressive which has the same meaning and values as for JPEG images. :compression is the image compression factor as an image between 0..9 . The default is 6 . TIFF images :color_depth which has the same meaning as for PNG images. Heif images :compression is the compression strategy to be applied. The allowable values are :hevc , :avc , :jpeg and :av1 . The default is :hevc .","ref":"Image.html#write/3","title":"Image.write/3","type":"function"},{"doc":"Returns the XMP data for an image as a keyword list. Only a selected set of XMP data is returned. Arguments image is any Vix.Vips.Image.t/0 Returns {:ok, xmp_map} where xmp_map is a map of selected XMP data.","ref":"Image.html#xmp/1","title":"Image.xmp/1","type":"function"},{"doc":"A composition is a 2-tuple defining an image and the options which describe how to compose this image on a base image.","ref":"Image.html#t:composition/0","title":"Image.composition/0","type":"type"},{"doc":"When composing an image on a base image, these options drive how the composition proceeds. :x describes the absolute x offset on the base image where this image will be placed. If this option is set to :left , :center or :right then the x position will be calculated relative to the base image. If :x is nil (the default) then the image will be placed according to the relative offset of the previously composed image using :dx . :y describes the absolute y offset on the base image where this image will be placed. If this option is set to :top , :middle or :bottom then the y position will be calculated relative to the base image. If :y is nil (the default) then the image will be placed according to the relative offset of the previously composed image using :dy . :dx describes the relative offset used to calculate the x value. :dx is an integer offset from the edge of the previously composed image. Which edge is determined by the :x_baseline option. If :x is also specified then :x is first calculated, then :dx is added to it. In this case, :x_baseline is ignored. :dy describes the relative offset used to calculate the y value. :dy is an integer offset from the edge of the previously composed image. Which edge is determined by the :y_baseline option. If :y is also specified then :y is first calculated, then :dy is added to it. In this case, :x_baseline is ignored. :blend_mode is the Image.BlendMode.t/0 used when composing this image over its base image. The default is :over which is appropriate for most use cases. :x_baseline establishes the baseline on the previously composed image from which :dx is calculated. The default is :right . :y_baseline establishes the baseline on the previously composed image from which :dy is calculated. The default is :bottom .","ref":"Image.html#t:composition_options/0","title":"Image.composition_options/0","type":"type"},{"doc":"Error messages returned by libvips Typically a string.","ref":"Image.html#t:error_message/0","title":"Image.error_message/0","type":"type"},{"doc":"The data type of the image, using the same type definitions as Nx.Type.t/0 .","ref":"Image.html#t:format/0","title":"Image.format/0","type":"type"},{"doc":"The valid sources of image data when opening an image.","ref":"Image.html#t:image_data/0","title":"Image.image_data/0","type":"type"},{"doc":"A 512 bit binary hash of an image. Useful for comparing the similarity of two images. See Image.dhash/1 and Image.hamming_distance/2 .","ref":"Image.html#t:image_hash/0","title":"Image.image_hash/0","type":"type"},{"doc":"Image orientation.","ref":"Image.html#t:orientation/0","title":"Image.orientation/0","type":"type"},{"doc":"A pixel is represented as a list of float values. The number of list elements is determined by the colorspace interpretations. For example: RGB colorspace would be represented by a list of three floats like [0.0, 0,0, 0.0] for black. CMYK colorspace would be represented by a list of four floats. A PNG image can be in any appropriate colorspace but may also have an alpha band and therefore have three, four or five floats in a list to represent the pixel.","ref":"Image.html#t:pixel/0","title":"Image.pixel/0","type":"type"},{"doc":"The valid rendering intent values. For all functions that take an optional intent parameter the default is :perceptual . Perceptual Intent Perceptual rendering is used to process photographic type images. This intent processes the colors so that the output reproduction is pleasing. This process tends to change the color from the original, so no guarantee the reproduction will be accurate against the original. Relative Intent Relative colorimetric changes all the colours out of gamut to the nearest colour in gamut, so many colours change to the same one. It DOES NOT change colours in gamut. Perceptual changes ALL the colours in the image in a proportional way so that they lie in the output device gamut. Saturation Intent Saturation moves in-gamut colors toward the edge of the destination gamut for maximum saturation and impact. This intent will make an image more colorful by using the full gamut of the destination device. This intent cares not for the genuine representation of color. Absolute Intent Absolute rendering attempts to reproduce all colors numerically (destination = source). This can cause unexpected results if the source gamut is larger than the destination.","ref":"Image.html#t:render_intent/0","title":"Image.render_intent/0","type":"type"},{"doc":"Functions to define and validate the band formats of an image.","ref":"Image.BandFormat.html","title":"Image.BandFormat","type":"module"},{"doc":"","ref":"Image.BandFormat.html#image_format_from_nx/1","title":"Image.BandFormat.image_format_from_nx/1","type":"function"},{"doc":"","ref":"Image.BandFormat.html#nx_format/1","title":"Image.BandFormat.nx_format/1","type":"function"},{"doc":"","ref":"Image.BandFormat.html#t:t/0","title":"Image.BandFormat.t/0","type":"type"},{"doc":"Functions to define and validate the blending modes that can be applied when composing images.","ref":"Image.BlendMode.html","title":"Image.BlendMode","type":"module"},{"doc":"Returns the default blend mode Example iex&gt; Image.BlendMode . default_blend_mode :VIPS_BLEND_MODE_OVER","ref":"Image.BlendMode.html#default_blend_mode/0","title":"Image.BlendMode.default_blend_mode/0","type":"function"},{"doc":"Returns the known blending modes. See Image.BlendMode.t/0 for a description of each mode.","ref":"Image.BlendMode.html#known_blend_modes/0","title":"Image.BlendMode.known_blend_modes/0","type":"function"},{"doc":"Normalizes and validates a blend mode. Argument blend_mode is one of Image.BlendMode.known_blend_modes/0 as either a String.t/0 or an atom . Returns {:ok, atom_blend_mode} where atom_blend_mode is a valid blend mode for libvips {:error, reason} Examples iex&gt; Image.BlendMode . validate_blend_mode :clear { :ok , :VIPS_BLEND_MODE_CLEAR } iex&gt; Image.BlendMode . validate_blend_mode &quot;Over&quot; { :ok , :VIPS_BLEND_MODE_OVER } iex&gt; Image.BlendMode . validate_blend_mode :VIPS_BLEND_MODE_XOR { :ok , :VIPS_BLEND_MODE_XOR } iex&gt; Image.BlendMode . validate_blend_mode :woops { :error , { :error , &quot;Unknown blend mode. Found :woops&quot; } }","ref":"Image.BlendMode.html#validate_blend_mode/1","title":"Image.BlendMode.validate_blend_mode/1","type":"function"},{"doc":"Blend mode to use when compositing images. See Image.compose/3 . :over the image shows what you would expect if you held two semi-transparent slides on top of each other. This is the default when composing images :clear where the second image is drawn, the first is removed :source the second image is drawn as if nothing were below :in the first image is removed completely, the second is only drawn where the first was :out the second is drawn only where the first isn't :atop this leaves the first image mostly intact, but mixes both images in the overlapping area :dest leaves the first image untouched, the second is discarded completely :dest_over like :over , but swaps the arguments :dest_in like :in , but swaps the arguments :dest_out like :out , but swaps the arguments :dest_atop like :atop , but swaps the arguments :xor something like a difference operator :add a bit like adding the two images :saturate a bit like the darker of the two :multiply at least as dark as the darker of the two inputs :screen at least as light as the lighter of the inputs :overlay multiplies or screens colors, depending on the lightness :darken the darker of each component :lighten the lighter of each component :colour_dodge brighten first by a factor second :colour_burn darken first by a factor of second :hard_light multiply or screen, depending on lightness :soft_light darken or lighten, depending on lightness :difference difference of the two :exclusion somewhat like :difference, but lower-contrast","ref":"Image.BlendMode.html#t:t/0","title":"Image.BlendMode.t/0","type":"type"},{"doc":"Functions to manage image color and color conversion.","ref":"Image.Color.html","title":"Image.Color","type":"module"},{"doc":"Returns a mapping from CSS color names to CSS hex values and RGB triplets as a list.","ref":"Image.Color.html#color_map/0","title":"Image.Color.color_map/0","type":"function"},{"doc":"Returns the list of color profiles built into libvips .","ref":"Image.Color.html#inbuilt_profiles/0","title":"Image.Color.inbuilt_profiles/0","type":"function"},{"doc":"Guards whether a given value can be interpreted as a color value.","ref":"Image.Color.html#is_color/1","title":"Image.Color.is_color/1","type":"macro"},{"doc":"Guards whether a given profile is one of the inbuilt profiles.","ref":"Image.Color.html#is_inbuilt_profile/1","title":"Image.Color.is_inbuilt_profile/1","type":"macro"},{"doc":"Returns a boolean indicating if the given profile is known and can be used for image operations.","ref":"Image.Color.html#known_icc_profile?/1","title":"Image.Color.known_icc_profile?/1","type":"function"},{"doc":"","ref":"Image.Color.html#normalize/1","title":"Image.Color.normalize/1","type":"function"},{"doc":"","ref":"Image.Color.html#rgb_color!/1","title":"Image.Color.rgb_color!/1","type":"function"},{"doc":"","ref":"Image.Color.html#rgb_color/1","title":"Image.Color.rgb_color/1","type":"function"},{"doc":"","ref":"Image.Color.html#rgba_color!/2","title":"Image.Color.rgba_color!/2","type":"function"},{"doc":"Reference to an ICC color profile :none means no profile :cmyk , :srgb and :p3 refer to the built-in color profiles Path.t() means any file system path. If the path is a relative path then is will be loaded from the systems profile directory.","ref":"Image.Color.html#t:icc_profile/0","title":"Image.Color.icc_profile/0","type":"type"},{"doc":"An rbg color expressed as a list of numbers. The number of list elements and the type varies depending on the image format, colorspace and dimensions. For a common sRGB image it will be a list of three of four images. If the fourth number is provided it will be considered as an alpha transparency band.","ref":"Image.Color.html#t:rgb_color/0","title":"Image.Color.rgb_color/0","type":"type"},{"doc":"A color can be expressed as a list of numbers or as a CSS color name in atom or string format.","ref":"Image.Color.html#t:t/0","title":"Image.Color.t/0","type":"type"},{"doc":"","ref":"Image.CombineMode.html","title":"Image.CombineMode","type":"module"},{"doc":"","ref":"Image.CombineMode.html#validate/1","title":"Image.CombineMode.validate/1","type":"function"},{"doc":"","ref":"Image.CombineMode.html#t:t/0","title":"Image.CombineMode.t/0","type":"type"},{"doc":"Functions to draw directly on a mutable image.","ref":"Image.Draw.html","title":"Image.Draw","type":"module"},{"doc":"Draw a circle on a mutable image. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the circle will be drawn. The image will be mutated. cx is the 0-based offset from the left edge of the image indicating where the center of the circle will be localed. cy is the 0-based offset from the top edge of the image indicating where the center of the circle will be localed. radius is the radius of the drawn circle. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . :fill is a boolean indicating whether the rectangle is to be filled with :color . The default is true . Returns {:ok, image} where image is the same type as that passed as an argument to the function. or {:error, reason}","ref":"Image.Draw.html#circle/5","title":"Image.Draw.circle/5","type":"function"},{"doc":"Flood-fill image with color, starting at position top , left . The filled area is bounded by pixels that are equal to the :colour . That is, it searches for pixels enclosed by an edge of :color . If :equal is true , it instead searches for pixels which are equal to the start point and fills them with :color . Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the the other image will be drawn. The image will be mutated. left is the 0-based offset from the left edge of the image where the flood will be drawn. top is the 0-based offset from the top edge of the image where the flood will drawn. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns {:ok, image} where image is the same type as that passed as an argument to the function. or {:error, reason}","ref":"Image.Draw.html#flood/4","title":"Image.Draw.flood/4","type":"function"},{"doc":"Draw one image over the top of a mutable image. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the the other image will be drawn. The image will be mutated. sub_image is any t:Vimage.t/0 that is drawn on top of image . left is the 0-based offset from the left edge of the image where the sub-image will be drawn. top is the 0-based offset from the top edge of the image where the sub-image will be drawn. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns {:ok, image} where image is the same type as that passed as an argument to the function. or {:error, reason}","ref":"Image.Draw.html#image/5","title":"Image.Draw.image/5","type":"function"},{"doc":"Draw a line on a mutable image. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the line will be drawn. The image will be mutated. x1 , y1 are the 0-based offsets from the left and top accordingly indicating the point at the start of the line. x2 , y2 are the 0-based offsets from the left and top accordingly indicating the point at the end of the line. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns {:ok, image} where image is the same type as that passed as an argument to the function. or {:error, reason}","ref":"Image.Draw.html#line/6","title":"Image.Draw.line/6","type":"function"},{"doc":"Draw mask on the image. Mask is a monochrome 8-bit image with the values of 0 or 255 for transparent and any other value as a color to be blended into the base image.","ref":"Image.Draw.html#mask/5","title":"Image.Draw.mask/5","type":"function"},{"doc":"Draw a point on a mutable image. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the point will be drawn. The image will be mutated. left is the 0-based offset from the left edge of the image where the point will be drawn. top is the 0-based offset from the top edge of the image where the point will be drawn. options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . Returns {:ok, image} where image is the same type as that passed as an argument to the function. or {:error, reason}","ref":"Image.Draw.html#point/4","title":"Image.Draw.point/4","type":"function"},{"doc":"Draw a rectangle on a mutable image. Arguments image is any t:Vimage.t/0 or a t:MutableImage.t/0 upon which the rectangle will be drawn. The image will be mutated. left is the 0-based offset from the left edge of the image where the rectangle will be drawn. top is the 0-based offset from the top edge of the image where the rectangle will be drawn. width is the width of the rectangle height is the height of the rectangle options is a keyword list of options. The default is color: :black . Options :color defines the color of the point. This can be specified as a single integer which will be applied to all bands, or a list of integers representing the color for each band. The color can also be supplied as a CSS color name as a string or atom. For example: :misty_rose . See Image.Color.color_map/0 and Image.Color.rgb_color/1 . :fill is a boolean indicating whether the rectangle is to be filled with :color . The default is true . Returns {:ok, image} where image is the same type as that passed as an argument to the function. or {:error, reason}","ref":"Image.Draw.html#rect/6","title":"Image.Draw.rect/6","type":"function"},{"doc":"Smudge a section of image . Each pixel in the area left , top , width , height is replaced by the average of the surrounding 3x3 pixels.","ref":"Image.Draw.html#smudge/6","title":"Image.Draw.smudge/6","type":"function"},{"doc":"Defines the known color interpretations to which an image can be converted to and from.","ref":"Image.Interpretation.html","title":"Image.Interpretation","type":"module"},{"doc":"Returns the known colorspace interpretations","ref":"Image.Interpretation.html#known_interpretations/0","title":"Image.Interpretation.known_interpretations/0","type":"function"},{"doc":"Normalizes and validates a color interpretation. Arguments interpretation is any atom or string value in Image.Interpretation.known_interpretations/0 . Returns {:error, normalized_interpretation} or {:error, reason} Examples iex&gt; Image.Interpretation . validate_interpretation ( :bw ) { :ok , :VIPS_INTERPRETATION_B_W } iex&gt; Image.Interpretation . validate_interpretation ( :VIPS_INTERPRETATION_sRGB ) { :ok , :VIPS_INTERPRETATION_sRGB } iex&gt; Image.Interpretation . validate_interpretation ( :unknown ) { :error , &quot;Unknown interpretation. Found :unknown&quot; }","ref":"Image.Interpretation.html#validate_interpretation/1","title":"Image.Interpretation.validate_interpretation/1","type":"function"},{"doc":"Defines the known colorspace interpretations.","ref":"Image.Interpretation.html#t:t/0","title":"Image.Interpretation.t/0","type":"type"},{"doc":"Implements math operators for images, delegating to the Kernel functions in the cases where the parameters do not include Vix.Vips.Image.t/0 . To override the standard operations in a function or module, add use Image.Math . To maximise readability and clarity it is recommended that use Image.Math be added to only those functions that require it. Example defmodule MyModule do # Not recommended use Image.Math def my_function ( % Vix.Vips.Image { } = image ) do # Recommended use Image.Math # Increase the all bands by 20% brigher = image * 1.2 # Or adjust only green by 20% bright_green = image * [ 1 , 1.2 , 1 ] end end","ref":"Image.Math.html","title":"Image.Math","type":"module"},{"doc":"Matrix inequality of two images or one image and a constant or vector. Delegates to Kernel.!=/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#!=/2","title":"Image.Math.!=/2","type":"function"},{"doc":"Matrix bitwise 'and' of two images.","ref":"Image.Math.html#&&&/2","title":"Image.Math.&&&/2","type":"function"},{"doc":"Matrix exponent of two images or one image and a constant or vector. Delegates to Kernel.**/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#**/2","title":"Image.Math.**/2","type":"function"},{"doc":"Matrix multiplation of two images or one image and a constant or vector. Delegates to Kernel.*/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#*/2","title":"Image.Math.*/2","type":"function"},{"doc":"Matrix addition of two images or one image and a constant or vector. Delegates to Kernel.+/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#+/2","title":"Image.Math.+/2","type":"function"},{"doc":"Matrix subtraction of two images or one image and a constant or vector. Delegates to Kernel.-/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#-/2","title":"Image.Math.-/2","type":"function"},{"doc":"Matrix division of two images or one image and a constant or vector. Delegates to Kernel.//2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#//2","title":"Image.Math.//2","type":"function"},{"doc":"Matrix less than of two images or one image and a constant or vector. Delegates to Kernel.&lt;/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#%3C/2","title":"Image.Math.</2","type":"function"},{"doc":"Matrix bitwise 'left shift' of two images.","ref":"Image.Math.html#%3C%3C%3C/2","title":"Image.Math.<<</2","type":"function"},{"doc":"Matrix less than or equal of two images or one image and a constant or vector. Delegates to Kernel.&lt;=/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#%3C=/2","title":"Image.Math.<=/2","type":"function"},{"doc":"Matrix equality of two images or one image and a constant or vector. Delegates to Kernel.==/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#==/2","title":"Image.Math.==/2","type":"function"},{"doc":"Matrix greater than of two images or one image and a constant or vector. Delegates to Kernel.&gt;/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#%3E/2","title":"Image.Math.>/2","type":"function"},{"doc":"Matrix greater than or equal of two images or one image and a constant or vector. Delegates to Kernel.&gt;=/2 if none of the parameters is a Vix.Vips.Image.t/0 .","ref":"Image.Math.html#%3E=/2","title":"Image.Math.>=/2","type":"function"},{"doc":"Matrix bitwise 'right shift' of two images.","ref":"Image.Math.html#%3E%3E%3E/2","title":"Image.Math.>>>/2","type":"function"},{"doc":"","ref":"Image.Math.html#add!/2","title":"Image.Math.add!/2","type":"function"},{"doc":"","ref":"Image.Math.html#add/2","title":"Image.Math.add/2","type":"function"},{"doc":"","ref":"Image.Math.html#boolean_and!/2","title":"Image.Math.boolean_and!/2","type":"function"},{"doc":"","ref":"Image.Math.html#boolean_and/2","title":"Image.Math.boolean_and/2","type":"function"},{"doc":"","ref":"Image.Math.html#boolean_lshift!/2","title":"Image.Math.boolean_lshift!/2","type":"function"},{"doc":"","ref":"Image.Math.html#boolean_lshift/2","title":"Image.Math.boolean_lshift/2","type":"function"},{"doc":"","ref":"Image.Math.html#boolean_or!/2","title":"Image.Math.boolean_or!/2","type":"function"},{"doc":"","ref":"Image.Math.html#boolean_or/2","title":"Image.Math.boolean_or/2","type":"function"},{"doc":"","ref":"Image.Math.html#boolean_rshift!/2","title":"Image.Math.boolean_rshift!/2","type":"function"},{"doc":"","ref":"Image.Math.html#boolean_rshift/2","title":"Image.Math.boolean_rshift/2","type":"function"},{"doc":"","ref":"Image.Math.html#boolean_xor!/2","title":"Image.Math.boolean_xor!/2","type":"function"},{"doc":"","ref":"Image.Math.html#boolean_xor/2","title":"Image.Math.boolean_xor/2","type":"function"},{"doc":"","ref":"Image.Math.html#cos!/1","title":"Image.Math.cos!/1","type":"function"},{"doc":"","ref":"Image.Math.html#cos/1","title":"Image.Math.cos/1","type":"function"},{"doc":"","ref":"Image.Math.html#divide!/2","title":"Image.Math.divide!/2","type":"function"},{"doc":"","ref":"Image.Math.html#divide/2","title":"Image.Math.divide/2","type":"function"},{"doc":"","ref":"Image.Math.html#equal!/2","title":"Image.Math.equal!/2","type":"function"},{"doc":"","ref":"Image.Math.html#equal/2","title":"Image.Math.equal/2","type":"function"},{"doc":"","ref":"Image.Math.html#greater_than!/2","title":"Image.Math.greater_than!/2","type":"function"},{"doc":"","ref":"Image.Math.html#greater_than/2","title":"Image.Math.greater_than/2","type":"function"},{"doc":"","ref":"Image.Math.html#greater_than_or_equal!/2","title":"Image.Math.greater_than_or_equal!/2","type":"function"},{"doc":"","ref":"Image.Math.html#greater_than_or_equal/2","title":"Image.Math.greater_than_or_equal/2","type":"function"},{"doc":"Guards if a given value might be reasonably interpreted as a pixel.","ref":"Image.Math.html#is_pixel/1","title":"Image.Math.is_pixel/1","type":"macro"},{"doc":"","ref":"Image.Math.html#less_than!/2","title":"Image.Math.less_than!/2","type":"function"},{"doc":"","ref":"Image.Math.html#less_than/2","title":"Image.Math.less_than/2","type":"function"},{"doc":"","ref":"Image.Math.html#less_than_or_equal!/2","title":"Image.Math.less_than_or_equal!/2","type":"function"},{"doc":"","ref":"Image.Math.html#less_than_or_equal/2","title":"Image.Math.less_than_or_equal/2","type":"function"},{"doc":"Return the image maximum. Arguments image is any Vix.Vips.Image.t/0 options is a keyword list of options Options :size is the number of maximums to find. The default is 10 . Returns {:ok, maximum, x_position, y_position}","ref":"Image.Math.html#maxpos/2","title":"Image.Math.maxpos/2","type":"function"},{"doc":"Return the image minimum. Arguments image is any Vix.Vips.Image.t/0 options is a keyword list of options Options :size is the number of minimums to find. The default is 10 . Returns {:ok, minimum, x_position, y_position}","ref":"Image.Math.html#minpos/2","title":"Image.Math.minpos/2","type":"function"},{"doc":"","ref":"Image.Math.html#multiply!/2","title":"Image.Math.multiply!/2","type":"function"},{"doc":"","ref":"Image.Math.html#multiply/2","title":"Image.Math.multiply/2","type":"function"},{"doc":"","ref":"Image.Math.html#not_equal!/2","title":"Image.Math.not_equal!/2","type":"function"},{"doc":"","ref":"Image.Math.html#not_equal/2","title":"Image.Math.not_equal/2","type":"function"},{"doc":"","ref":"Image.Math.html#pow!/2","title":"Image.Math.pow!/2","type":"function"},{"doc":"","ref":"Image.Math.html#pow/2","title":"Image.Math.pow/2","type":"function"},{"doc":"","ref":"Image.Math.html#sin!/1","title":"Image.Math.sin!/1","type":"function"},{"doc":"","ref":"Image.Math.html#sin/1","title":"Image.Math.sin/1","type":"function"},{"doc":"","ref":"Image.Math.html#subtract!/2","title":"Image.Math.subtract!/2","type":"function"},{"doc":"","ref":"Image.Math.html#subtract/2","title":"Image.Math.subtract/2","type":"function"},{"doc":"Matrix bitwise 'or' of two images.","ref":"Image.Math.html#%7C%7C%7C/2","title":"Image.Math.|||/2","type":"function"},{"doc":"Detects and decodes QRcodes. Note that the implementation, which is based upon eVision requires that the image be a 3-channel image in order to support detection. Images that are in different formats must be converted first.","ref":"Image.QRcode.html","title":"Image.QRcode","type":"module"},{"doc":"Detects and decodes a QR code in an image. Arguments image is any Vix.Vips.Image.t/0 that has three bands (for example, a typical srgb image). Returns {:ok, string} or {:error, reason} Note Only images with three bands (channels) are supported. This restriction may be lifted in a future release.","ref":"Image.QRcode.html#decode/1","title":"Image.QRcode.decode/1","type":"function"},{"doc":"","ref":"Image.SetSafeLoader.html","title":"Image.SetSafeLoader","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Image.SetSafeLoader.html#child_spec/1","title":"Image.SetSafeLoader.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Image.SetSafeLoader.html#init/1","title":"Image.SetSafeLoader.init/1","type":"function"},{"doc":"Functions to render a shape as an image. The supported shapes match those defined in Scalable Vector Graphics including: Polygon Circle Ellipse Line","ref":"Image.Shape.html","title":"Image.Shape","type":"module"},{"doc":"","ref":"Image.Shape.html#aspect_ratio/1","title":"Image.Shape.aspect_ratio/1","type":"function"},{"doc":"Creates an image of a polygon as a single band image on a transparent background. Arguments points defines the points of the polygon. The origin is the top left of the image with a positive x value moving from right to left and a positive y value moving from top to bottom. The points can be an SVG point string or a &quot;list of lists&quot; of the form [[x1, y1], [x2, y2], ...] where x1 and y1 are integers. options is a Keyword.t/0 list of options. Options :width is the width of the canvas onto which the polygon is drawn. The default is 500 pixels. :height is the width of the canvas onto which the polygon is drawn. The default is 500 pixels. :fill_color is the color used to fill in the polygon. The default is :none . :stroke_color is the color used for the outline of the polygon. The default is :black :opacity is the opacity as a float between 0.0 and 1.0 where 0.0 is completely transparent and 1.0 is completely opaque. The default is 0.7 . Notes The polygon points are scaled to fit the canvas size defined by :width and :height This means that the resulting image will fill the canvas. This is useful for composing images. Define the canvas to be the size intended to be composed into a base image and the polygon will be scaled to fit. Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;. Returns image or raises an exception Examples","ref":"Image.Shape.html#polygon!/2","title":"Image.Shape.polygon!/2","type":"function"},{"doc":"Creates an image of a polygon as a single band image on a transparent background. Arguments points defines the points of the polygon. The origin is the top left of the image with a positive x value moving from right to left and a positive y value moving from top to bottom. The points can be an SVG point string or a &quot;list of lists&quot; of the form [[x1, y1], [x2, y2], ...] where x1 and y1 are integers. points can also be a positive integer &gt;= 3 which indicates that an n sided polygon will be generated. In this case the options :rotation and :radius are also applicable. options is a Keyword.t/0 list of options. Options :width is the width of the canvas onto which the polygon is drawn. The default is 500 pixels. :height is the width of the canvas onto which the polygon is drawn. The default is 500 pixels. :fill_color is the color used to fill in the polygon. The default is :none . :stroke_color is the color used for the outline of the polygon. The default is :black :opacity is the opacity as a float between 0.0 and 1.0 where 0.0 is completely transparent and 1.0 is completely opaque. The default is 0.7 . :rotation is the number of degrees to rotate the axis of a generated n-sided polygon. This option is only valid if points is an integer &gt;= 3. The default is 180 . :radius indicates the radius in pixels of a generated n-sided polygon. The default is 100 . Notes The polygon points are scaled to fit the canvas size defined by :width and :height This means that the resulting image will fill the canvas. This is useful for composing images. Define the canvas to be the size intended to be composed into a base image and the polygon will be scaled to fit. Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;. Returns {:ok, image} or {:error, reason} Examples","ref":"Image.Shape.html#polygon/2","title":"Image.Shape.polygon/2","type":"function"},{"doc":"Returns an image of an n-pointed star that can be composed over other images. Arguments points is an integer number of points on the star. points must be &gt;= 3. The default is 5 . options is a Keyword.t/0 list of options. Options :inner_radius is the size of the inner radius. The default is 60 . :outer_radius is the size of the outer radius. The default is 60 . :rotation is the angle in degrees of rotation applied to the points. The default is 0 . Any remaining options are passed to Image.Shape.polygon/2 . Returns image or raises an exception Examples #=&gt; star = Image.Shape.star! #=&gt; star = Image.Shape.star! 5, rotation: 90, fill_color: :red, stroke_color: :green","ref":"Image.Shape.html#star!/2","title":"Image.Shape.star!/2","type":"function"},{"doc":"Returns an image of an n-pointed star that can be composed over other images. Arguments points is an integer number of points on the star. points must be &gt;= 3. The default is 5 . options is a Keyword.t/0 list of options. Options :inner_radius is the size of the inner radius. The default is 60 . :outer_radius is the size of the outer radius. The default is 150 . :rotation is the angle in degrees of rotation applied to the points. The default is 0 . Any remaining options are passed to Image.Shape.polygon/2 . Returns {:ok, image} or {:error, reason} Examples #=&gt; {:ok, star} = Image.Shape.star #=&gt; {:ok, star} = Image.Shape.star 5, rotation: 90, fill_color: :red, stroke_color: :green","ref":"Image.Shape.html#star/2","title":"Image.Shape.star/2","type":"function"},{"doc":"A path is a list of points representing a path, open polygon or closed polygon.","ref":"Image.Shape.html#t:path/0","title":"Image.Shape.path/0","type":"type"},{"doc":"A point is a list of two integers representing the x and y coordinates","ref":"Image.Shape.html#t:point/0","title":"Image.Shape.point/0","type":"type"},{"doc":"Functions to introspect standard image sizes for various social media platforms.","ref":"Image.Social.html","title":"Image.Social","type":"module"},{"doc":"Returns the default image type that an image is resized to for a given platform is no :type parameter is peovided. Arguments platform is any known social platform. See Image.Social.known_platforms/0 . Returns The default image type for the platform. Example","ref":"Image.Social.html#default_image_usage/1","title":"Image.Social.default_image_usage/1","type":"function"},{"doc":"Returns the image types for the given social platform. Arguments platform is any known social platform. See Image.Social.known_platforms/0 . Returns A list of images uses available for the platform. Example","ref":"Image.Social.html#image_usages/1","title":"Image.Social.image_usages/1","type":"function"},{"doc":"Returns a list of known social platforms. Example","ref":"Image.Social.html#known_platforms/0","title":"Image.Social.known_platforms/0","type":"function"},{"doc":"Return the map of social media image sizes. The returned map of maps is of a standard form: The first key is the platform name (ie :twitter ) The second key is the image type for the platform (ie :profile ) The third level is optional. But if it exists it must have three keys: :landscape , :portrait and :square The values are all of the form &quot;WxH&quot; where W is the width in pixels and H is the height in pixels.","ref":"Image.Social.html#media_sizes/0","title":"Image.Social.media_sizes/0","type":"function"},{"doc":"Resize an image for a particular social platform and usage. This function: Resizes an image to the correct dimensions, including being image orientation aware Converts to the sRGB color space Minimises metadata (retains only Artist and Copyright) Arguments image is any Vix.Vips.Image.t/0 platform is the name of a known social media platform. See Image.Social.known_platforms/0 . options is a keyword list of options. Options :type is the image type within the social platform for which the image should be resized. See Image.Social.image_usages/1 All other options are passed to Image.resize!/3 . Returns resized_image or Raises an exception.","ref":"Image.Social.html#resize!/3","title":"Image.Social.resize!/3","type":"function"},{"doc":"Resize an image for a particular social platform and usage. This function: Resizes an image to the correct dimensions, including being image orientation aware Converts to the sRGB color space Minimises metadata (retains only Artist and Copyright) Arguments image is any Vix.Vips.Image.t/0 platform is the name of a known social media platform. See Image.Social.known_platforms/0 . options is a keyword list of options. Options :type is the image type within the social platform for which the image should be resized. See Image.Social.image_usages/1 All other options are passed to Image.resize!/3 . Returns {:ok, resized_image} or {:error, reason}","ref":"Image.Social.html#resize/3","title":"Image.Social.resize/3","type":"function"},{"doc":"The social media platform image usage.","ref":"Image.Social.html#t:image_usage/0","title":"Image.Social.image_usage/0","type":"type"},{"doc":"The known social media platforms.","ref":"Image.Social.html#t:platform/0","title":"Image.Social.platform/0","type":"type"},{"doc":"Functions for the creation of images from text.","ref":"Image.Text.html","title":"Image.Text","type":"module"},{"doc":"Adds a background to an image generated from text returning and image or raising an exception. Arguments image is any t:Vimage.t/0 but is expected to be an image generated by Image.Text.text/2 . options is a Keyword.t/0 list of options Options :background_fill_color is the background fill color behind the text. The default is :none which indicates no background. Note that if :background_fill_opacity is the opacity of the background. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . Returns image or raises an exception Notes Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#add_background!/2","title":"Image.Text.add_background!/2","type":"function"},{"doc":"Adds a background to an image generated from text. Arguments image is any t:Vimage.t/0 but is expected to be an image generated by Image.Text.text/2 . options is a Keyword.t/0 list of options Options :background_fill_color is the background fill color behind the text. The default is :none which indicates no background. Note that if :background_fill_opacity is the opacity of the background. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . Returns {:ok, image} or {:error, reason} Notes Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#add_background/2","title":"Image.Text.add_background/2","type":"function"},{"doc":"Adds a border on an image, typically an image generated from a string. Returns an image or raises an exception. Arguments image is any t:Vimage.t/0 options is a Keyword.t/0 list of options Options :background_stroke_color is the colour of the outline of the background. The default is &quot;none&quot;, :background_stroke_width is the integer size in pixels of the background border. The default is 1 . :background_stroke_opacity is the opacity of the background string. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . Returns image or raises an exception Notes Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#add_background_border!/2","title":"Image.Text.add_background_border!/2","type":"function"},{"doc":"Adds a border on an image, typically an image generated from a string. Arguments image is any t:Vimage.t/0 options is a Keyword.t/0 list of options Options :background_stroke_color is the colour of the outline of the background. The default is &quot;none&quot;, :background_stroke_width is the integer size in pixels of the background border. The default is 1 . :background_stroke_opacity is the opacity of the background string. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . Returns {:ok, image} or {:error, reason} Notes Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#add_background_border/2","title":"Image.Text.add_background_border/2","type":"function"},{"doc":"Adds padding to a background to an image generated from text returning an image or raising an exception. Arguments image is any t:Vimage.t/0 but is expected to be an image generated by Image.Text.add_background/2 . options is a Keyword.t/0 list of options Options :background_fill_color is the background fill color behind the text. The default is :none which indicates no background. Note that if :background_fill_opacity is the opacity of the background. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . :padding is the padding in pixels between the text and the edge of the background. It can be expressed as a single integer integer in which case the same padding is applied to all four sides of the image. It can also be expressed as a list of two integers like [0, 0] . The first integer will be used as the padding for the left and right of the image. The second integer will be used for the top and bottom of the image. Another alternative is to pass a t:Vimage.t/0 in which case the padding will be derived from the image dimensions such that the background covers the whole of the impage. THe default is [0, 0] . Returns image or raises an exception Notes Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#add_background_padding!/2","title":"Image.Text.add_background_padding!/2","type":"function"},{"doc":"Adds padding to a background to an image generated from text. Arguments image is any t:Vimage.t/0 but is expected to be an image generated by Image.Text.add_background/2 . options is a Keyword.t/0 list of options Options :background_fill_color is the background fill color behind the text. The default is :none which indicates no background. Note that if :background_fill_opacity is the opacity of the background. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . :padding is the padding in pixels between the text and the edge of the background. It can be expressed as a single integer integer in which case the same padding is applied to all four sides of the image. It can also be expressed as a list of two integers like [0, 0] . The first integer will be used as the padding for the left and right of the image. The second integer will be used for the top and bottom of the image. Another alternative is to pass a t:Vimage.t/0 in which case the padding will be derived from the image dimensions such that the background covers the whole of the impage. THe default is [0, 0] . Returns {:ok, image} or {:error, reason} Notes Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#add_background_padding/2","title":"Image.Text.add_background_padding/2","type":"function"},{"doc":"Creates an image from the provided text and returns an image or raises an exception. This function creates an image from the text but does not apply a background or padding. Arguments string is any string. The string will be HTML-escapeed to avoid malicious code injection. If you are completely confident that the text is safe then you can pass it by calling with Phoenix.HTML.raw/1 on the string first. options is a Keyword.t/0 list of options Options :font is any font recognised on the host system. The default is&quot;Helvetica&quot;. :font_size is an integer font size in pixels. The dfault is 50 . :font_weight is the font weight . The alternatives :normal , :bold , :lighter , :bolder , or an integer between 1 and 1_000 . The default is :normal which is equivalent to 400 . :text_fill_color is the fill color of the text. The default is &quot;white&quot;. If set to :transparent then the text will be rendered transparently against a background. A black background will be forced if a :background_fill_color is not provided :text_stroke_color is the color of the outline of each character in the string. The default is &quot;none&quot;. :text_stroke_width is the integer width in pixels of the outline of each character in the string. The default is 1 . Returns image or raises an exception Notes There is no text wrapping, justification or kerning applied. This means this function is not a general purpose text layout function and is suitable mostly for overlaying text for emphasis over another image. Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#simple_text!/2","title":"Image.Text.simple_text!/2","type":"function"},{"doc":"Creates an image from the provided text. This function creates an image from the text but does not apply a background or padding. Arguments string is any string. The string will be HTML-escapeed to avoid malicious code injection. If you are completely confident that the text is safe then you can pass it by calling with Phoenix.HTML.raw/1 on the string first. options is a Keyword.t/0 list of options Options :font is any font recognised on the host system. The default is&quot;Helvetica&quot;. :font_size is an integer font size in pixels. The dfault is 50 . :font_weight is the font weight . The alternatives :normal , :bold , :lighter , :bolder , or an integer between 1 and 1_000 . The default is :normal which is equivalent to 400 . :text_fill_color is the fill color of the text. The default is &quot;white&quot;. If set to :transparent then the text will be rendered transparently against a background. A black background will be forced if a :background_fill_color is not provided :text_stroke_color is the color of the outline of each character in the string. The default is &quot;none&quot;. :text_stroke_width is the integer width in pixels of the outline of each character in the string. The default is 1 . Returns {:ok, image} or {:error, reason} Notes There is no text wrapping, justification or kerning applied. This means this function is not a general purpose text layout function and is suitable mostly for overlaying text for emphasis over another image. Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#simple_text/2","title":"Image.Text.simple_text/2","type":"function"},{"doc":"Create a new image from the provided string and formatting options returning an image or raising an exception. text!/2 creates an image with the following steps: Render the text Add an optional background color Expand the background according to the required padding The text can be rendered as a positive (the default) in which an image of the provided string is rendered in the provided font, weight, size, fill color and stroke color. It can also be rendered transparently in which case a background color is required against which the transparent text can be composed. If not provided, the background color will be black. After rendering the text and composing it against the (optional) background, the background can be expanded to provide some padding between the text and any base image onto which it is later composed. The default no padding. Arguments string is any string. The string will be HTML-escapeed to avoid malicious code injection. If you are completely confident that the text is safe then you can pass it by calling with Phoenix.HTML.raw/1 on the string first. options is a Keyword.t/0 list of options Options :font is any font recognised on the host system. The default is&quot;Helvetica&quot;. :font_size is an integer font size in pixels. The dfault is 50 . :font_weight is the font weight . The alternatives :normal , :bold , :lighter , :bolder , or an integer between 1 and 1_000 . The default is :normal which is equivalent to 400 . :text_fill_color is the fill color of the text. The default is &quot;white&quot;. If set to :transparent then the text will be rendered transparently against a background. A black background will be forced if a :background_fill_color is not provided :text_stroke_color is the color of the outline of each character in the string. The default is &quot;none&quot;. :text_stroke_width is the integer width in pixels of the outline of each character in the string. The default is 1 . :background_fill_opacity is the opacity of the background fill. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . :padding is the padding in pixels between the text and the edge of the background. It can be expressed as a single integer integer in which case the same padding is applied to all four sides of the image. It can also be expressed as a list of two integers like [0, 0] . The first integer will be used as the padding for the left and right of the image. The second integer will be used for the top and bottom of the image. Another alternative is to pass a t:Vimage.t/0 in which case the padding will be derived from the image dimensions such that the background covers the whole of the impage. THe default is [0, 0] . :background_fill_color is the background fill color behind the text. The default is :none which indicates no background. Note that if :background_stroke_color is the colour of the outline of the background. The default is &quot;none&quot;, :background_stroke_width is the integer size in pixels of the background border. The default is 1 . :background_stroke_opacity is the opacity of the background string. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . Returns image or raises an exception Notes There is no text wrapping, justification or kerning applied. This means this function is not a general purpose text layout function and is suitable mostly for overlaying text for emphasis over another image. Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#text!/2","title":"Image.Text.text!/2","type":"function"},{"doc":"Create a new image from the provided string and formatting options. text/2 creates an image with the following steps: Render the text Add an optional background color Expand the background according to the required padding The text can be rendered as a positive (the default) in which an image of the provided string is rendered in the provided font, weight, size, fill color and stroke color. It can also be rendered transparently in which case a background color is required against which the transparent text can be composed. If not provided, the background color will be black. After rendering the text and composing it against the (optional) background, the background can be expanded to provide some padding between the text and any base image onto which it is later composed. The default no padding. Arguments string is any string. The string will be HTML-escapeed to avoid malicious code injection. If you are completely confident that the text is safe then you can pass it by calling with Phoenix.HTML.raw/1 on the string first. options is a Keyword.t/0 list of options Options :font is any font recognised on the host system. The default is&quot;Helvetica&quot;. :font_size is an integer font size in pixels. The dfault is 50 . :font_weight is the font weight . The alternatives :normal , :bold , :lighter , :bolder , or an integer between 1 and 1_000 . The default is :normal which is equivalent to 400 . :text_fill_color is the fill color of the text. The default is &quot;white&quot;. If set to :transparent then the text will be rendered transparently against a background. A black background will be forced if a :background_fill_color is not provided :text_stroke_color is the color of the outline of each character in the string. The default is &quot;none&quot;. :text_stroke_width is the integer width in pixels of the outline of each character in the string. The default is 1 . :background_fill_opacity is the opacity of the background fill. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . :padding is the padding in pixels between the text and the edge of the background. It can be expressed as a single integer integer in which case the same padding is applied to all four sides of the image. It can also be expressed as a list of two integers like [0, 0] . The first integer will be used as the padding for the left and right of the image. The second integer will be used for the top and bottom of the image. Another alternative is to pass a t:Vimage.t/0 in which case the padding will be derived from the image dimensions such that the background covers the whole of the impage. THe default is [0, 0] . :background_fill_color is the background fill color behind the text. The default is :none which indicates no background. Note that if :background_stroke_color is the colour of the outline of the background. The default is &quot;none&quot;, :background_stroke_width is the integer size in pixels of the background border. The default is 1 . :background_stroke_opacity is the opacity of the background string. It is a float between 0.0 and 1.0 where 0.0 means transparent and 1.0 means opaque. The default is 0.7 . Returns {:ok, image} or {:error, reason} Notes There is no text wrapping, justification or kerning applied. This means this function is not a general purpose text layout function and is suitable mostly for overlaying text for emphasis over another image. Colors may be any valid CSS color name or a six hexadecimal digit string prefixed with # . For example #FF00FF for the color &quot;Fuchsia&quot;.","ref":"Image.Text.html#text/2","title":"Image.Text.text/2","type":"function"},{"doc":"Options and option validation for Image.avatar/3 .","ref":"Image.Options.Avatar.html","title":"Image.Options.Avatar","type":"module"},{"doc":"","ref":"Image.Options.Avatar.html#validate_options/1","title":"Image.Options.Avatar.validate_options/1","type":"function"},{"doc":"","ref":"Image.Options.Avatar.html#t:avatar_options/0","title":"Image.Options.Avatar.avatar_options/0","type":"type"},{"doc":"Options and option validation for Image.crop/5 .","ref":"Image.Options.Crop.html","title":"Image.Options.Crop","type":"module"},{"doc":"","ref":"Image.Options.Crop.html#validate_option/2","title":"Image.Options.Crop.validate_option/2","type":"function"},{"doc":"","ref":"Image.Options.Crop.html#validate_options/1","title":"Image.Options.Crop.validate_options/1","type":"function"},{"doc":"Indicates how to determine where to crop an image to fill a target area. :none means the image will be reduced to fit the required bounding box and no cropping will occur. :center means crop from the center of the image. The central part of the image will be returned, cropped to fill the bounding box. :entropy uses an entropy measure. :attention means crop the image by looking for features likely to draw human attention. :low means position the crop towards the low coordinate. This means the bottom part of the image remains after the crop. :high means position the crop towards the high coordinate. This means the top part of the image remains after the crop.","ref":"Image.Options.Crop.html#t:crop_focus/0","title":"Image.Options.Crop.crop_focus/0","type":"type"},{"doc":"Options applicable to cropping an image. Currently there are no options.","ref":"Image.Options.Crop.html#t:crop_options/0","title":"Image.Options.Crop.crop_options/0","type":"type"},{"doc":"Options for the draw functions.","ref":"Image.Options.Draw.html","title":"Image.Options.Draw","type":"module"},{"doc":"","ref":"Image.Options.Draw.html#default_options/1","title":"Image.Options.Draw.default_options/1","type":"function"},{"doc":"Validate the options for Image.Draw .","ref":"Image.Options.Draw.html#validate_options/2","title":"Image.Options.Draw.validate_options/2","type":"function"},{"doc":"","ref":"Image.Options.Draw.html#t:circle/0","title":"Image.Options.Draw.circle/0","type":"type"},{"doc":"","ref":"Image.Options.Draw.html#t:flood/0","title":"Image.Options.Draw.flood/0","type":"type"},{"doc":"","ref":"Image.Options.Draw.html#t:image/0","title":"Image.Options.Draw.image/0","type":"type"},{"doc":"","ref":"Image.Options.Draw.html#t:line/0","title":"Image.Options.Draw.line/0","type":"type"},{"doc":"","ref":"Image.Options.Draw.html#t:mask/0","title":"Image.Options.Draw.mask/0","type":"type"},{"doc":"","ref":"Image.Options.Draw.html#t:point/0","title":"Image.Options.Draw.point/0","type":"type"},{"doc":"","ref":"Image.Options.Draw.html#t:rect/0","title":"Image.Options.Draw.rect/0","type":"type"},{"doc":"","ref":"Image.Options.Draw.html#t:smudge/0","title":"Image.Options.Draw.smudge/0","type":"type"},{"doc":"Options for new images.","ref":"Image.Options.New.html","title":"Image.Options.New","type":"module"},{"doc":"","ref":"Image.Options.New.html#default_options/0","title":"Image.Options.New.default_options/0","type":"function"},{"doc":"Validate the options for Image.new/2 .","ref":"Image.Options.New.html#validate_options/1","title":"Image.Options.New.validate_options/1","type":"function"},{"doc":"","ref":"Image.Options.New.html#t:t/0","title":"Image.Options.New.t/0","type":"type"},{"doc":"Options and option validation for Image.open/2 .","ref":"Image.Options.Open.html","title":"Image.Options.Open","type":"module"},{"doc":"","ref":"Image.Options.Open.html#validate_option/2","title":"Image.Options.Open.validate_option/2","type":"function"},{"doc":"","ref":"Image.Options.Open.html#validate_options/1","title":"Image.Options.Open.validate_options/1","type":"function"},{"doc":"Stop attempting to load an image file when a level of error is detected. The default is :none . Each error state implies all the states before it such that :error implies also :truncated .","ref":"Image.Options.Open.html#t:fail_on/0","title":"Image.Options.Open.fail_on/0","type":"type"},{"doc":"The file access mode when opening image files. The default in :sequential .","ref":"Image.Options.Open.html#t:file_access/0","title":"Image.Options.Open.file_access/0","type":"type"},{"doc":"The options applicable to opening an image.","ref":"Image.Options.Open.html#t:image_open_options/0","title":"Image.Options.Open.image_open_options/0","type":"type"},{"doc":"","ref":"Image.Options.Open.html#t:jpeg_open_options/0","title":"Image.Options.Open.jpeg_open_options/0","type":"type"},{"doc":"","ref":"Image.Options.Open.html#t:other_open_options/0","title":"Image.Options.Open.other_open_options/0","type":"type"},{"doc":"","ref":"Image.Options.Open.html#t:png_open_options/0","title":"Image.Options.Open.png_open_options/0","type":"type"},{"doc":"","ref":"Image.Options.Open.html#t:tiff_open_options/0","title":"Image.Options.Open.tiff_open_options/0","type":"type"},{"doc":"","ref":"Image.Options.Open.html#t:webp_open_options/0","title":"Image.Options.Open.webp_open_options/0","type":"type"},{"doc":"Options and option validation for Image.resize/3 .","ref":"Image.Options.Resize.html","title":"Image.Options.Resize","type":"module"},{"doc":"Validate the options for Image.resize/2 . See Image.Options.Resize.resize_options/0 .","ref":"Image.Options.Resize.html#validate_options/1","title":"Image.Options.Resize.validate_options/1","type":"function"},{"doc":"","ref":"Image.Options.Resize.html#t:resize_dimension/0","title":"Image.Options.Resize.resize_dimension/0","type":"type"},{"doc":"Options applicable to Image.resize/3","ref":"Image.Options.Resize.html#t:resize_options/0","title":"Image.Options.Resize.resize_options/0","type":"type"},{"doc":"Options and option validation for Image.rotate/3 .","ref":"Image.Options.Rotate.html","title":"Image.Options.Rotate","type":"module"},{"doc":"Validate the options for Image.rotate/3 . See Image.Options.Rotate.rotation_options/0 .","ref":"Image.Options.Rotate.html#validate_options/1","title":"Image.Options.Rotate.validate_options/1","type":"function"},{"doc":"The options applicable to rotating an image.","ref":"Image.Options.Rotate.html#t:rotation_options/0","title":"Image.Options.Rotate.rotation_options/0","type":"type"},{"doc":"Options for text drawing.","ref":"Image.Options.Text.html","title":"Image.Options.Text","type":"module"},{"doc":"","ref":"Image.Options.Text.html#default_options/0","title":"Image.Options.Text.default_options/0","type":"function"},{"doc":"Validate the options for Image.Text.text/2 .","ref":"Image.Options.Text.html#validate_options/1","title":"Image.Options.Text.validate_options/1","type":"function"},{"doc":"","ref":"Image.Options.Text.html#t:t/0","title":"Image.Options.Text.t/0","type":"type"},{"doc":"Options and option validation for Image.write/3 .","ref":"Image.Options.Write.html","title":"Image.Options.Write","type":"module"},{"doc":"","ref":"Image.Options.Write.html#validate_options/1","title":"Image.Options.Write.validate_options/1","type":"function"},{"doc":"","ref":"Image.Options.Write.html#validate_options/2","title":"Image.Options.Write.validate_options/2","type":"function"},{"doc":"Allowble compression types for heif images.","ref":"Image.Options.Write.html#t:compression/0","title":"Image.Options.Write.compression/0","type":"type"},{"doc":"","ref":"Image.Options.Write.html#t:heif_write_options/0","title":"Image.Options.Write.heif_write_options/0","type":"type"},{"doc":"Options for writing an image to a file with Image.write/2 .","ref":"Image.Options.Write.html#t:image_write_options/0","title":"Image.Options.Write.image_write_options/0","type":"type"},{"doc":"","ref":"Image.Options.Write.html#t:jpeg_write_options/0","title":"Image.Options.Write.jpeg_write_options/0","type":"type"},{"doc":"","ref":"Image.Options.Write.html#t:png_write_options/0","title":"Image.Options.Write.png_write_options/0","type":"type"},{"doc":"","ref":"Image.Options.Write.html#t:tiff_write_options/0","title":"Image.Options.Write.tiff_write_options/0","type":"type"},{"doc":"","ref":"Image.Options.Write.html#t:webp_write_options/0","title":"Image.Options.Write.webp_write_options/0","type":"type"},{"doc":"","ref":"Image.Exif.html","title":"Image.Exif","type":"module"},{"doc":"Extract EXIF data from a binary blob.","ref":"Image.Exif.html#extract_exif/1","title":"Image.Exif.extract_exif/1","type":"function"},{"doc":"","ref":"Image.Exif.html#field/1","title":"Image.Exif.field/1","type":"function"},{"doc":"","ref":"Image.Exif.html#read_exif/2","title":"Image.Exif.read_exif/2","type":"function"},{"doc":"","ref":"Image.Exif.html#t:context/0","title":"Image.Exif.context/0","type":"type"},{"doc":"","ref":"Image.Exif.html#t:t/0","title":"Image.Exif.t/0","type":"type"},{"doc":"","ref":"Image.Exif.html#t:value/0","title":"Image.Exif.value/0","type":"type"},{"doc":"Defines the field names with mapping to the relevant EXIF IFD. This is useful for mapping developer and user friendly names to the internal header names in libvips .","ref":"Image.Exif.FieldNames.html","title":"Image.Exif.FieldNames","type":"module"},{"doc":"","ref":"Image.Exif.FieldNames.html#vips_header_name/1","title":"Image.Exif.FieldNames.vips_header_name/1","type":"function"},{"doc":"","ref":"Image.Xmp.html","title":"Image.Xmp","type":"module"},{"doc":"","ref":"Image.Xmp.html#extract_xmp/1","title":"Image.Xmp.extract_xmp/1","type":"function"},{"doc":"Image is an image processing library for Elixir. It is based upon the fabulous vix library that provides a libvips wrapper for Elixir. Image is intended to provide well-documented common image processing functions in an idiomatic Elixir functional style as a layer above the very comprehensive set of functions in Vix and libvips . It is also intended to be an idiomatic API layer over eVision (OpenCV) . As of Image verison 0.9.0 , the Image.QRcode.decode/1 function is provided to decode QRcodes with the functionality to do so provided by eVision . The eVision integration is optional and currently considered experimental. In a very simple image resizing benchmark , Image is approximately 2 to 3 times faster than Mogrify and uses about 5 times less memory.","ref":"readme.html","title":"Image","type":"extras"},{"doc":"Image can be installed by adding image to your list of dependencies in mix.exs : def deps do [ { :image , &quot;~&gt; 0.9.0&quot; } ] end The documentation can be found at https://hexdocs.pm/image . Installing Libvips Installing Vix requires libvips with development headers. Installation is platform dependent however the common platform installations are: macOS: Install using homebrew with brew install libvips Linux: Install with apt install libvips-dev For more details see https://www.libvips.org/install.html In addition the following will be required (and would normally be installed by the steps above): pkg-config A C compiler Configuring Libvips Vix and libvips offer various configuration parameters that affect debug output, image caching, concurrency of imaging operations and memory leak detection. Each of these options has reasonable defaults so no action is required in order to start using the library. Vix NIF Error Logging Vix NIF code writes logs to stderr on certain errors. This is disabled by default. To enable logging set the VIX_LOG_ERROR environment variable to true . GLib Debug Output The platform upon which Image and Vix stand is libvips , a C library that performs the image manipulation. It's libvips that delivers the speed, memory efficiency and functionality. libvips uses the GLib library which has configurable debug output. This output depends on the setting of the environment variable G_DEBUG . The initial value will depend on the installation method of libvips for a given system. It can be changed by setting the G_DEBUG environment variable to one of the following: fatal-warnings which causes GLib to abort the operation at the first call to g_warning() or g_critical(). fatal-criticals causes GLib to abort the operation at the first call to g_critical(). gc-friendly causes newly allocated memory that isn't directly initialized, as well as memory being freed to be reset to 0. The point here is to allow memory checkers and similar programs that use Boehm GC alike algorithms to produce more accurate results. resident-modules causes all modules loaded by GModule will be made resident. This can be useful for tracking memory leaks in modules which are later unloaded; but it can also hide bugs where code is accessed after the module would have normally been unloaded. bind-now-modules causes all modules loaded by GModule to bind their symbols at load time, even when the code uses %G_MODULE_BIND_LAZY. To produce debug output for only the most critical issues, set G_DEBUG as follows (in bash and compatible shells): export G_DEBUG=fatal-criticals Memory Leak Detection The environment variable VIPS_LEAK determines whether libvips reports possible memory leaks. To enable leak detection (on bash compatible systems): export VIPS_LEAK=true To stop leak detection: unset VIPS_LEAK Concurrency Image (because of Vix and libvips ) will execute concurrent image operations using a number of system native threads (not BEAM processes). The number of threads available for concurrent image operations is configurable by either setting the environment variable VIPS_CONCURRENCY or through a call to Image.put_concurrency/1 . The current number of configured threads is returned from Image.get_concurrency/0 . The default number of threads is equal to the number of cores detected on the running system. This may create CPU contention with other workloads given that image processing is CPU intensive. Therefore it may be prudent to reduce the number of threads if overall system throughput is being affected. Security Considerations There are several considerations in the use of any image processing library and any NIF-based library: If a NIF crashes it will likely bring down the BEAM virtual machine. libvips is a robust, time-tested library however this risk cannot be eliminated. Image processing is CPU intensive with its concurrent pipelining model and default concurrency level equal to the number of cores in the host machine, CPU starvation for other parts of the application is a possibility. In such cases, reducing the libvips concurrency is recommended. Image processing by its nature operates on external data and there have been exploits based upon maliciously crafted images. The two primary vectors are: An invalid image format that causes the image parser to crash and therefore crash the NIF and the BEAM Executable code embedded in image metadata (such as EXIF data) that if passed un-escaped to a web browser may result in arbitrary code execution. In comparison to Imagemagick that has a reported 638 CVEs, there have been only 8 CVE's reported for libvips , each resolved in a very timely manner. Installing eVision As of Image version 0.9.0 , experimental support for eVision (OpenCV) is provided. There is extensive documentation on how to install eVision and the required OpenCV . However to most cases the following should be enough: Add eVision to your mix.exs def deps do [ ... { :evision , &quot;~&gt; 0.1&quot; } , ... ] end Get deps mix deps . get Then proceed as normal. eVision will download a precompiled OpenCV for the appropriate system architecture and compile both the NIF and elixir code. Note that many Elixir compiler warnings will be emitted; this is to be expected on the current development versions of eVision .","ref":"readme.html#installation","title":"Image - Installation","type":"extras"},{"doc":"Copyright 2022 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is the changelog for Image version 0.11.0 released on October 8th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Now uses eVision version 0.1 or later from hex.pm","ref":"changelog.html#image-0-11-0","title":"Changelog - Image 0.11.0","type":"extras"},{"doc":"This is the changelog for Image version 0.10.0 released on October 5th, 2022. For older changelogs please consult the release tag on GitHub Bug Fixes Since the mix build process does a File.cwd!/1 to the directory of each dependency we can't use the dirname of the dependency to decide whether to configure :evision or not. The strategy is now changed to configure :evision only if the environment CONFIGURE_EVISION is set. Note this is only relevant when developing :image itself. Consumers of the library should add :evision as a dependency manually in their application mix.exs as described in the readme . Thanks to @martosaur for the report. Closes #13.","ref":"changelog.html#image-0-10-0","title":"Changelog - Image 0.10.0","type":"extras"},{"doc":"This is the changelog for Image version 0.9.0 released on October 1st, 2022. For older changelogs please consult the release tag on GitHub Enhancements Image.open/2 supports opening .gif and .tif images from raw binary data in addition to the previous .jpeg , .png and .webp . Add Image.shape/1 Add Image.interpretation/1 Add Image.type/1 Add initial support for eVision . In this release the function Image.QRcode.decode/1 is provided to decode images that contain a QRcode. See the eVision repository for installation instructions since this library is not yet on hex.pm . Removed most dialyzer warnings. The remaining warnings require an update to Vix (a PR has been submitted).","ref":"changelog.html#image-0-9-0","title":"Changelog - Image 0.9.0","type":"extras"},{"doc":"This is the changelog for Image version 0.8.0 released on September 30, 2022. For older changelogs please consult the release tag on GitHub Enhancements Image.open/2 now accepts raw image data for the image types .jpeg , .png , .webp","ref":"changelog.html#image-0-8-0","title":"Changelog - Image 0.8.0","type":"extras"},{"doc":"This is the changelog for Image version 0.7.0 released on September 30, 2022. For older changelogs please consult the release tag on GitHub Enhancements Set the environment variable VIPS_BLOCK_UNTRUSTED at application start if it is not already set. As of libvips 8.13 this environment variable will cause libvips to not use any image loaders that are &quot;unfuzzed&quot;. Add mutable draw operations. These operations mutate an image directly and hence special care is taken to avoid race conditions. All mutuable operations are serialized via a GenServer . See the Image.Draw module. These functions are experimental for now pending additional testing. Add Image.from_binary/2 to support creating an image from a raw binary. Thanks to @timothyvanderaerden for the PR to support getting dialyzer under control. Work will continue on this over the next several releases.","ref":"changelog.html#image-0-7-0","title":"Changelog - Image 0.7.0","type":"extras"},{"doc":"This is the changelog for Image version 0.6.0 released on July 19th, 2022. For older changelogs please consult the release tag on GitHub Bug fixes Don't attempt to compile code that refers to Plug.t if Plug is not configured. Thanks to @kwando. Closes #7. Enhancements Adds Image.dshash/1 to return a 512-bit image hash. Adds Image.hamming_distance/2 to compare the similarity of two images or two image hashes. Adds Image.radial_gradient/3 to great a radial gradient image. This could be used to composite over another image to add a vignette. Adds Image.Math logical functions boolean_and/2 , boolean_or/2 , boolean_xor/2 , boolean_lshift/2 and boolean_rshift/2 . Also includes the ! versions. Add operator use Image.Math overloads for image &amp;&amp;&amp; ( and ), ||| ( or ), &lt;&lt;&lt; ( lshift ) and &gt;&gt;&gt; ( rshift ).","ref":"changelog.html#image-0-6-0","title":"Changelog - Image 0.6.0","type":"extras"},{"doc":"This is the changelog for Image version 0.5.0 released on June 24th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Adds Image.to_nx/1 to convert an image to an Nx tensor. Adds Image.from_nx/1 to convert an Nx tensor into an image.","ref":"changelog.html#image-0-5-0","title":"Changelog - Image 0.5.0","type":"extras"},{"doc":"This is the changelog for Image version 0.4.0 released on June 23rd, 2022. For older changelogs please consult the release tag on GitHub Enhancements Adds support for opening streaming images. This allows images to be streamed from File.stream!/3 or from any t:Stream.t/0 including those created from ExAws.S3 by ExAws.stream!/2 . Adds support writing streaming images. This allows images to be streamed as an enumerable which can then be consumed by Plug.Conn.chunk/2 , by ExAws.S3.upload/3 , File.stream/3 or any other function that processes stream resources. See the test/stream_image_test.exs for examples. Adds a :memory option to Image.write/3 . Instead of a path name or stream, use :memory if you'd like to return a binary form of an image in its formatted type. Note that this will run the image transformation pipeline resulting in the entire final image being loaded into memory. Therefore this option should be used sparingly since most use cases do not require this option. It is primarily added to facilitate passing images to other libraries in the Elixir ecosystem.","ref":"changelog.html#image-0-4-0","title":"Changelog - Image 0.4.0","type":"extras"},{"doc":"This is the changelog for Image version 0.3.0 released on June 4th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Add Image.dominant_color/2 to return the dominant color of an image Add Image.histogram/1 to return a histogram of an image Add Image.get_pixel to get the pixel value at a given x and y offset into an image.","ref":"changelog.html#image-0-3-0","title":"Changelog - Image 0.3.0","type":"extras"},{"doc":"This is the changelog for Image version 0.2.0 released on May 18th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Adds Image.Text to support generating an image from a string. See Image.Text.text/2 . Adds Image.Shape to support generating images from shapes. In this release there is a generalised support for polygons and stars. See Image.Shape.polygon/2 and Image.Shape.star/2 . Improves Image.compose/3 to support composing with image lists, relative image placement and more.","ref":"changelog.html#image-0-2-0","title":"Changelog - Image 0.2.0","type":"extras"},{"doc":"This is the changelog for Image version 0.1.0 released on May 4th, 2022. For older changelogs please consult the release tag on GitHub Enhancements Initial release","ref":"changelog.html#image-0-1-0","title":"Changelog - Image 0.1.0","type":"extras"},{"doc":".column { float: left; width: 33.33%; padding: 5px; } /* Clear floats after image containers */ .row::after { content: \"\"; clear: both; display: table; } figure { border: 3px solid #FF1493; display: flex; flex-flow: column; padding: 0; width: 200px; height: 200px; margin: auto; width: 200px; height: 200px; } img { max-width: 200px; max-height: 200px; padding: 0; margin: 0 } figcaption { background-color: #222; color: #fff; font: smaller sans-serif; margin-top: 10px; padding: 3px; text-align: center; } Image.resize(image, 200, crop: :none) Image.resize(image, 200, crop: :attention) Image.crop!(image, 550, 320, 200, 200) image |> Image.resize!(200, crop: :attention) |> Image.rounded!() Image.avatar(image, 200)","ref":"examples.html","title":"Example Usage","type":"extras"}]